/*
 * ScenarioGraphEditorFactory.java
 *
 * Created on 13 maj 2004, 12:26
 */

package pl.psnc.vlab.graph;

import pl.psnc.vlab.ssa.exception.SSAException;
import pl.psnc.vlab.ssa.gui.MainFrame;
import pl.psnc.vlab.xml.ScenarioBuilder;

/**
 * The factory is responsible for creating destroying and
 * storing the JGraph Editor.
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class ScenarioGraphEditorFactory {
    
    /** The Scenario graph editor instance */
    private static ScenarioGraphEditor instance = null;
    
    /** Gets the instance of the Dynamic Scenario Graph Editor
     * @throws SSAException
     * @return
     */
    public static ScenarioGraphEditor getGraphEditorInstance() throws SSAException {
        if(instance == null){
            instance = createNewInstance();
        }
        return instance;
    }
    
    
    /** Create a new Scenario Graph Editor
     * @return
     */
    public static ScenarioGraphEditor createNewInstance() throws SSAException {
        instance = new ScenarioGraphEditor();
        ScenarioBuilder.createInstace(null);
        //set title
        //MainFrame.getInstance().updateTitle(null);
        return instance;
    }
    
}
