/*
 * CustomCellViewFactory.java
 *
 * Created on 8 listopad 2006, 16:33
 */

package pl.psnc.vlab.graph.model;

import org.jgraph.graph.CellView;
import org.jgraph.graph.DefaultCellViewFactory;
import org.jgraph.graph.GraphModel;
import org.jgraph.graph.PortView;
import org.jgraph.graph.VertexView;
import pl.psnc.vlab.graph.view.CustomPortView;
import pl.psnc.vlab.graph.view.ImageVertexView;

/**
 * The custom implementation of Cell View Factory
 *
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email  osa@man.poznan.pl
 */
public class CustomCellViewFactory extends DefaultCellViewFactory {
    
    
    
    
    /**
     * Creates a port view
     * @param object cell object
     * @return new port view
     */
    protected PortView createPortView(Object cell) {
        return new CustomPortView(cell);
    }
    
    
    /**
     * Creates vertex view
     * @param object
     * @return
     */
    protected VertexView createVertexView(Object object) {        
        return new ImageVertexView(object);
    }
    
       
    
    
}
