/*
 * ScenarioGraphSelectionListener.java
 *
 * Created on 6 sierpie� 2004, 16:17
 */

package pl.psnc.vlab.graph.model;
import java.util.ArrayList;
import javax.swing.Action;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jgraph.event.GraphSelectionEvent;
import org.jgraph.event.GraphSelectionListener;
import pl.psnc.vlab.ssa.actions.ActionFactory;

/**
 *
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class ScenarioGraphSelectionListener implements GraphSelectionListener{
    
    /** Instance of logger*/
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Stores an instance of the scenario graph */
    private ScenarioGraph graph = null;
    
    /** Stores the list of selected cells*/
    private Object selection[] = null;
    
    /** Stores the list of listeners*/
    private ArrayList listeners;
    
    /** Creates a new instance of ScenarioGraphSelectionListener */
    public ScenarioGraphSelectionListener(ScenarioGraph graph) {
        this.graph = graph;
    }
    
        
    /**
     * Add the given observers to the observer list
     * @param listener 
     */
    public void addListener(Object listener){
        if(this.listeners == null){
            this.listeners = new ArrayList();
        }
        if(listener !=null){
            this.listeners.add(listener);
        }
    }
    
    
    public void valueChanged(GraphSelectionEvent graphSelectionEvent) {
        int selectionCount = graph.getSelectionCount();
        Action deleteAction = ActionFactory.getAction(ActionFactory.ACTION_DELETE);
        Action copyAction   = ActionFactory.getAction(ActionFactory.ACTION_COPY);
        deleteAction.setEnabled(selectionCount >0);
        copyAction.setEnabled(selectionCount >0);
        /*Object o = graphSelectionEvent.getCell();
        if(o != null){
            DefaultGraphCell cell = (DefaultGraphCell)o;
            // Create Attributes for Vertex            
            AttributeMap attributes = cell.getAttributes();
            GraphConstants.setBorderColor(attributes, Color.green);
            cell.changeAttributes(attributes);
        }*/
        
        
        //notify observers
        int size = listeners != null ? listeners.size() : 0;
        for(int i=0; i<size; i++){
            ((GraphSelectionObserver) listeners.get(0)).update(graph.getSelectionCells());
        }
        
    }
    
}
