/*
 * ScenarioUndoManager.java
 *
 * Created on 1 kwiecien 2004, 10:54
 */

package pl.psnc.vlab.graph.model;

import javax.swing.Action;
import javax.swing.event.UndoableEditEvent;
import org.jgraph.graph.GraphUndoManager;

/**
 * Scenario undo manager. 
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class ScenarioUndoManager extends GraphUndoManager{
    
    /** Instance of JGraph*/
    private ScenarioGraph graph = null;
    
    /** Actions which Change State */
    protected Action undo,
    redo,
    remove,
    group,
    ungroup,
    tofront,
    toback,
    cut,
    copy,
    paste;
    
    /** Creates a new instance of ScenarioUndoManager */
    public ScenarioUndoManager(ScenarioGraph graph) {
        super();
        this.graph = graph;
    }
    
    // Override Superclass
    public void undoableEditHappened(UndoableEditEvent e) {
        // First Invoke Superclass
        super.undoableEditHappened(e);
        // Then Update Undo/Redo Buttons
        //updateHistoryButtons();
    }
    
    
    // Update Undo/Redo Button State based on Undo Manager
	protected void updateHistoryButtons() {
		// The View Argument Defines the Context
		undo.setEnabled(this.canUndo(graph.getGraphLayoutCache()));
		redo.setEnabled(this.canRedo(graph.getGraphLayoutCache()));
	}
}
