/*
 * GXLFileFilter.java
 *
 * Created on 20 kwiecien 2004, 12:40
 */

package pl.psnc.vlab.graph.util;

import javax.swing.filechooser.FileFilter;
import pl.psnc.vlab.util.FileTools;

/**
 * File filter for JFileChooser dialogs.
 * It filters all the GXL format files.
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class GXLFileFilter extends FileFilter {
            
    /** Accept all directories and files with jgx extension
     * @param f file
     * @return
     */    
    public boolean accept(java.io.File f) {
         if (f.isDirectory()) {
            return true;
        }

        String extension = FileTools.getExtension(f);
        if (extension != null) {
            if (extension.equals(FileTools.jgx)) {
                    return true;
            } else {
                return false;
            }
        }

        return false;
    }
    
    /** Returns description of this filter
     * @return
     */    
    public String getDescription() {
        return java.util.ResourceBundle.getBundle("bundle/jgraph").getString("gxl.file.filter.desc");
    }
    
}
