/*
 * ImageVertexView.java
 *
 * Created on 5 kwiecie� 2004, 14:00
 */

package pl.psnc.vlab.graph.view;

import java.awt.Component;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.Hashtable;
import java.util.Map;
import javax.swing.Icon;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jgraph.JGraph;
import org.jgraph.graph.CellViewRenderer;
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.PortView;
import org.jgraph.graph.VertexRenderer;
import org.jgraph.graph.VertexView;
import pl.psnc.vlab.graph.model.ScenarioCellObject;
import pl.psnc.vlab.graph.renderer.ImageVertexRenderer;
import pl.psnc.vlab.graph.renderer.RendererFactory;
import pl.psnc.vlab.graph.util.GraphHelper;
import pl.psnc.vlab.graph.util.GraphKeys;
import pl.psnc.vlab.graph.vertex.ImageCell;

/**
 * Image vertex view. Overrides the default
 * JGraph vertex view to support image as cells
 * @author  Dominik Stok�osa
 * @email  osa@man.poznan.pl
 */
public class ImageVertexView extends VertexView{
    
    /** Instance of logger*/
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    
    /**
     * Creates new instance of ImageVertexView
     * @param cell cell object
     */
    public ImageVertexView(Object cell) {
        super(cell);
    }
    
    
    
    /** Get Experiment Vertex default renderer */
    public CellViewRenderer getRenderer() {
        ImageCell imageCell = (ImageCell) getCell();
        ScenarioCellObject cellObject = (ScenarioCellObject) imageCell.getUserObject();
        ImageVertexRenderer r = RendererFactory.getRenderer( GraphHelper.getResourceImage(cellObject.getType().getTypeId()).getImageName() );
        return r;
    }
    
    public Component getRendererComponent(JGraph jGraph, boolean selected, boolean focus, boolean preview) {
        
        //log.debug("IMAGE_VIEW-> foces="+selected+" sel="+focus+" prew="+preview);
       /* if(selected){
            Object portTmp =  jGraph.getModel().getChild(getCell(), 0);
            PortView port = (PortView) jGraph.getGraphLayoutCache().getMapping(portTmp, false);
            //Component c = port.getRendererComponent(jGraph, true, focus, preview);
            //  c.repaint();
        }*/
        return super.getRendererComponent(jGraph, selected, focus, preview);
    }
    
    public void update(JGraph graph, Point2D p) {
        Icon icon =  ( (VertexRenderer) getRenderer()).getIcon();
        Rectangle2D bounds = new Rectangle2D.Double(p.getX(), p.getY(), icon.getIconWidth(), icon.getIconHeight() + GraphKeys.VERTEX_LABEL_MARGIN );
        Map transportMap = new Hashtable();
        GraphConstants.setBounds(transportMap, bounds);
        Map nestedMap = new Hashtable();
        nestedMap.put(cell, transportMap);
        graph.getModel().edit(nestedMap, null, null, null);
        //super.update();
    }
    
    
    
    
    
    
    
}
