package pl.psnc.vlab.ssa.actions;

import java.awt.event.ActionEvent;
import javax.swing.Action;
import javax.swing.KeyStroke;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.rds.ScenarioDocument;
import pl.psnc.vlab.ssa.gui.MainFrame;
import pl.psnc.vlab.ssa.gui.scenario.ScenarioPropertiesDialog;
import pl.psnc.vlab.ssa.util.ImageKeys;
import pl.psnc.vlab.ssa.util.i18n.SSABundleFactory;
import pl.psnc.vlab.util.FormTools;
import pl.psnc.vlab.util.image.ImageFactory;
import pl.psnc.vlab.xml.ScenarioBuilder;



/**
 *
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class ScenarioPropertiesAction extends AbstractActionDefault {
    
    /** Instance of logger*/
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /**
     * Creates a new instance of Scenario Properties Action. The action is used
     * to open an Scenario properties dialog          
     */
    public ScenarioPropertiesAction(){
        super(SSABundleFactory.getValue("action.scenario.properties.name") , ImageFactory.getImageBean(ImageKeys.ICON_COPY).getImage() );
        this.putValue(Action.SHORT_DESCRIPTION, SSABundleFactory.getValue("action.scenario.properties.tip"));
        this.putValue(Action.SMALL_ICON, ImageFactory.getImageBean(ImageKeys.ICON_PROPERTIES).getImage());
        String mnemonic = SSABundleFactory.getValue("action.scenario.properties.mnemonic");
        KeyStroke keyStroke = KeyStroke.getKeyStroke(FormTools.toUpperLetterAndDigit(mnemonic));
        this.putValue(Action.MNEMONIC_KEY, new Integer(keyStroke.getKeyCode()) );
        this.putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke(SSABundleFactory.getValue("action.scenario.properties.shortcut"))); //keyStroke);                
    }
    
    /**
     * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        ScenarioDocument.Scenario scenario = ScenarioBuilder.getScenarioDescription();
        new ScenarioPropertiesDialog(MainFrame.getInstance(), true, scenario).show();
    }
    
    
    
}
