package pl.psnc.vlab.ssa.actions.perspective;

import java.awt.event.ActionEvent;
import javax.swing.Action;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.ssa.actions.AbstractActionDefault;
import pl.psnc.vlab.ssa.gui.MainFrameBase;
import pl.psnc.vlab.ssa.util.ImageKeys;
import pl.psnc.vlab.ssa.util.i18n.SSABundleFactory;
import pl.psnc.vlab.util.image.ImageFactory;
import pl.psnc.vlab.util.swing.gui.GuiTools;




/**
 * Action for the available actions perspective
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class AvailableActionsPerpAction extends AbstractActionDefault {
    
    /** Instance of logger*/
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Instance of the MainFrameBase*/
    private MainFrameBase mainFrameBase;
    
    /**
     * Creates a new instance of zoom in Action.  The action is created with the default
     * name, icons, mnemonic and accelerator key - these are taken from the
     * resource bundle
     */
    public AvailableActionsPerpAction(MainFrameBase mainFrameBase){
        super(SSABundleFactory.getValue("action.availale.actions.pers.name") , ImageFactory.getImageBean(ImageKeys.ICON_AVAILABLE_ACTIONS_VIEW).getImage() );
        this.mainFrameBase = mainFrameBase;
        this.putValue(Action.SHORT_DESCRIPTION, SSABundleFactory.getValue("action.availale.actions.pers.tip"));
        this.putValue(Action.SMALL_ICON, ImageFactory.getImageBean(ImageKeys.ICON_AVAILABLE_ACTIONS_VIEW).getImage());
        this.putValue(GuiTools.PROPERTY_DISABLED_ICON, ImageFactory.getImageBean(ImageKeys.ICON_AVAILABLE_ACTIONS_VIEW_DISABLED).getImage());               
    }
    
    /**
     * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
      
    }
    
    

    /**
     * Holds value of property visible.
     */
    private boolean visible;

    /**
     * Getter for property visible.
     * @return Value of property visible.
     */
    public boolean isVisible() {

        return this.visible;
    }

    /**
     * Setter for property visible.
     * @param visible New value of property visible.
     */
    public void setVisible(boolean visible) {

        this.visible = visible;
    }
}
