package pl.psnc.vlab.ssa.actions.perspective;

import java.awt.event.ActionEvent;
import javax.swing.AbstractButton;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.ssa.actions.AbstractActionDefault;
import pl.psnc.vlab.ssa.gui.MainFrameBase;
import pl.psnc.vlab.ssa.util.ImageKeys;
import pl.psnc.vlab.ssa.util.i18n.SSABundleFactory;
import pl.psnc.vlab.util.image.ImageFactory;




/**
 * The zoom in Action
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class ResInfPerspAction extends AbstractActionDefault {
    
    /** Instance of logger*/
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Instance of the MainFrameBase*/
    private MainFrameBase mainFrameBase;
    
    /** List of parents object*/
    private Object parent[];
    
    /**
     * Creates a new instance of zoom in Action.  The action is created with the default
     * name, icons, mnemonic and accelerator key - these are taken from the
     * resource bundle
     * @param parent parent object, which is bundeled to this action
     * @param mainFrameBase
     */
    public ResInfPerspAction(Object parent[], MainFrameBase mainFrameBase){
        super(SSABundleFactory.getValue("action.resource.info.pers.name") , ImageFactory.getImageBean(ImageKeys.ICON_RESOURCE_INFO_VIEW).getImage());
        this.mainFrameBase = mainFrameBase;
        this.putValue(Action.SHORT_DESCRIPTION, SSABundleFactory.getValue("action.resource.info.pers.tip"));
        ImageIcon icon  = ImageFactory.getImageBean(ImageKeys.ICON_RESOURCE_INFO_VIEW).getImage();
        this.putValue(Action.SMALL_ICON, icon);
        //this.putValue(AbstractActionDefault.PARENT_OBJECT, parent);
        this.parent = parent;
    }
    
    /**
     * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        setVisible(! isVisible());
        if(e == null){      //action was called manually
            ( (AbstractButton) parent[0]).setSelected(isVisible());
            ( (AbstractButton) parent[1]).setSelected(isVisible());
        } else if(e.getSource() == parent[0]){
            ( (AbstractButton) parent[1]).setSelected(isVisible());
        } else if(e.getSource() == parent[1]){
            ( (AbstractButton) parent[0]).setSelected(isVisible());
        }
        log.debug("Visibled-"+isVisible());
        mainFrameBase.setResourceOutlineVisible(isVisible());
    }
    
    
    
    /**
     * Holds value of property visible.
     */
    private boolean visible;
    
    /**
     * Getter for property visible.
     * @return Value of property visible.
     */
    public boolean isVisible() {
        
        return this.visible;
    }
    
    /**
     * Setter for property visible.
     * @param visible New value of property visible.
     */
    public void setVisible(boolean visible) {
        
        this.visible = visible;
    }
}
