/*
 * DynamicScenarioExceptionCodes.java
 *
 * Created on 19 marzec 2004, 10:44
 */

package pl.psnc.vlab.ssa.exception;

/**
 * The class stores an exception codes for all the errors.
 * @author  osa
 * @email osa@man.poznan.pl
 */
public class SSAExceptionCodes {
    
    /** Creates a new instance of DynamicScenarioExceptionCodes */
    public SSAExceptionCodes() {
    }

    
    //-----------   Soap and Vlab remote exceptions
    /** Indicates an error call to the VLab System */
    public static int VLAB_REMOTE_ERROR_CALL = 801;
    
    //-----------   Java Exception
    /** Indicates java.lang.Exception */
    public static int GENERAL_EXCEPTION = 1;
    
    public static int CONNECTION_REFUSED = 1;
    
    
    //-----------   XML exceptions - 10
    /** org.xml.sax.SAXParseException: */
    public static int XML_SAX_PARSE_EXC =  101;
    

    //-----------  App specyfic exceptions
    /** User session is not valid */
    public static int APP_SESSION_NOT_VALID =  901;
}
