
package pl.psnc.vlab.ssa.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;
import com.jgoodies.uif_lite.component.*;
import com.jgoodies.uif_lite.panel.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jgraph.JGraph;
import org.jgraph.util.JGraphUtilities;
import pl.psnc.vlab.graph.ScenarioGraphEditor;
import pl.psnc.vlab.graph.ScenarioGraphEditorFactory;
import pl.psnc.vlab.graph.model.GraphSelectionObserver;
import pl.psnc.vlab.graph.model.ScenarioCellObject;
import pl.psnc.vlab.graph.util.GraphHelper;
import pl.psnc.vlab.ssa.actions.ActionFactory;
import pl.psnc.vlab.ssa.gui.event.MsgEventPane;
import pl.psnc.vlab.ssa.gui.main.ResourceInfoOutlinePane;
import pl.psnc.vlab.ssa.gui.scenario.*;
import pl.psnc.vlab.util.swing.gui.*;
import pl.psnc.vlab.xml.ScenarioBuilder;

/*
 * Created by JFormDesigner on Tue Oct 25 15:05:31 CEST 2005
 */



/**
 * @author Dominik Stoklosa
 */
public class MainFrameBase extends JPanel implements GraphSelectionObserver, Observer {
    
    /** Instance of logger*/
    private  Log log = LogFactory.getLog(getClass().getName());
    
    /** Stores the value of outline pane */
    private ResourceInfoOutlinePane resourceInfoOutlinePane;
    
    /** Stores the value of Message Log Table */
    private MsgEventPane msgEventPane;
    
    /** Stores the value of lase left divider location */
    private int lastLeftDividerLocation;
    
    /** Stores the value of lase left divider location */
    private int lastCenterDividerLocation;
    
    public MainFrameBase() {
        this.resourceInfoOutlinePane = new ResourceInfoOutlinePane();
        initComponents();
        
        initUserComponent();
        JResourceInfoPane.setVisible(false);
        JContentScrollPane.setVisible(false);
        lastLeftDividerLocation = jLeftSplitPane.getDividerLocation();
        
        lastCenterDividerLocation = jRightSplitPane.getDividerLocation();
    }
    
    
    
    
    /** Initialize the user components */
    private void initUserComponent(){
        this.msgEventPane = new MsgEventPane(this);
        jRightSplitPane.setBottomComponent(this.msgEventPane);
        this.msgEventPane.setVisible(false);
    }
    
    
    /**
     * Initialize the Rosource Inf. Pane listeners
     * @param graphSelectionListener
     */
    public void initResourceInfo(ScenarioGraphEditor graphEditor){
        //set resourece outline pane to default state
        update(new Object[0]);
        graphEditor.getGraph().getScenarioGraphSelectionListener().addListener(this);
        //removed graph 10.1 graphEditor.getGraph().getGraphLayoutCache().addObserver(this);
    }
    
    private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY//GEN-BEGIN:initComponents
		// Generated using JFormDesigner non-commercial license
		ResourceBundle bundle = ResourceBundle.getBundle("pl.psnc.vlab.ssa.gui.MainFrameBaseBundle");
		DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
		jLeftSplitPane = new UIFSplitPane();
		JResourceInfoPane = new SimpleInternalFrame();
		JContentScrollPane = new JScrollPane();
		jContentPane = new GenericGradientPane(ColorKeys.GRADIENT_LIGHT_GRAY_AND_WHITE[1],
		ColorKeys.GRADIENT_LIGHT_GRAY_AND_WHITE[0]);
		jResoureTypeTile = compFactory.createSeparator(bundle.getString("pane.resource.info.jResoureTypeTile.text"));
		jResourceTypeTF = new JLabel();
		jResourceNameTile = compFactory.createSeparator(bundle.getString("pane.resource.info.jResourceNameTile.text"));
		jResourceNameTF = new JLabel();
		jResourceDescTile = compFactory.createSeparator(bundle.getString("pane.resource.info.jResourceDescTile.text"));
		jResourceDescTA = new JTextArea();
		JLinkScrollPane = new JScrollPane();
		jLinkContentPane = new GenericGradientPane(new Color(203, 201, 188), Color.white);
		goodiesFormsTitle1 = compFactory.createTitle(bundle.getString("pane.resource.info.goodiesFormsTitle1.textWithMnemonic"));
		jSrcNodeIdTitle = compFactory.createSeparator(bundle.getString("pane.resource.info.jSrcNodeIdTitle.text"));
		jSrcNodeIdTxtFld = new JTextField();
		jSrcNodeNameTitle = compFactory.createSeparator(bundle.getString("pane.resource.info.jSrcNodeNameTitle.text"));
		jSrcNodeNameTxtFld = new JTextField();
		goodiesFormsTitle2 = compFactory.createTitle(bundle.getString("pane.resource.info.goodiesFormsTitle2.textWithMnemonic"));
		jTrgtNodeIdTitle = compFactory.createSeparator(bundle.getString("pane.resource.info.jTrgtNodeIdTitle.text"));
		jTrgtNodeIdTxtFld = new JTextField();
		jTrgtNodeNameTitle = compFactory.createSeparator(bundle.getString("pane.resource.info.jTrgtNodeNameTitle.text"));
		jTrgtNodeNameTxtFld = new JTextField();
		JScenScrollPane = new JScrollPane();
		jScenDetailsPane = new JScenarioDetailsPane(ScenarioBuilder.getScenarioDescription());
		jRightSplitPane = new UIFSplitPane();
		jGraphEditorIFr = new SimpleInternalFrame();
		JGraphEditorScrollPane = new JScrollPane();
		jResourceToolBar = new JToolBar();
		jRICloseBtn = new JButton();
		JViewToolBar = new JToolBar();
		jViewChanger = new JComboBox();
		jResInfoScrollPaneOLD = new JScrollPane();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
		setLayout(new FormLayout(
			new ColumnSpec[] {
				FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
				new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
				FormFactory.LABEL_COMPONENT_GAP_COLSPEC
			},
			new RowSpec[] {
				FormFactory.LINE_GAP_ROWSPEC,
				new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
				FormFactory.LINE_GAP_ROWSPEC
			}));

		//======== jLeftSplitPane ========
		{
			jLeftSplitPane.setResizeWeight(0.1);
			jLeftSplitPane.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
			jLeftSplitPane.setDividerBorderVisible(false);
			jLeftSplitPane.setDividerSize(0);
			jLeftSplitPane.setToolTipText(bundle.getString("pane.resource.info.jLeftSplitPane.toolTipText"));

			//======== JResourceInfoPane ========
			{
				JResourceInfoPane.setTitle("Resource Info");
				JResourceInfoPane.setFrameIcon(new ImageIcon(getClass().getResource("/images/buttons/outline_co.gif")));
				JResourceInfoPane.setToolBar(jResourceToolBar);
				JResourceInfoPane.setContentPaneBorder(null);
				JResourceInfoPane.setMinimumSize(new Dimension(80, 100));
				JResourceInfoPane.setPreferredSize(new Dimension(150, 147));
				Container JResourceInfoPaneContentPane = JResourceInfoPane.getContentPane();
				JResourceInfoPaneContentPane.setLayout(new FormLayout(
					"default:grow",
					"fill:default:grow"));

				//======== JContentScrollPane ========
				{
					JContentScrollPane.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
					JContentScrollPane.setOpaque(false);
					JContentScrollPane.setPreferredSize(new Dimension(0, 0));
					JContentScrollPane.setMinimumSize(new Dimension(0, 0));
					JContentScrollPane.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
					JContentScrollPane.setVisible(false);

					//======== jContentPane ========
					{
						jContentPane.setMinimumSize(new Dimension(80, 65));
						jContentPane.setMaximumSize(new Dimension(32767, 1000));
						jContentPane.setPreferredSize(new Dimension(200, 300));
						jContentPane.setAutoscrolls(true);
						jContentPane.setLayout(new FormLayout(
							new ColumnSpec[] {
								new ColumnSpec(ColumnSpec.LEFT, Sizes.DLUX6, FormSpec.NO_GROW),
								FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
								FormFactory.UNRELATED_GAP_COLSPEC,
								FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
								new ColumnSpec(ColumnSpec.LEFT, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
								FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
								new ColumnSpec(Sizes.DLUX6)
							},
							new RowSpec[] {
								FormFactory.LINE_GAP_ROWSPEC,
								FormFactory.LINE_GAP_ROWSPEC,
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(RowSpec.TOP, Sizes.DLUY5, FormSpec.NO_GROW),
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(RowSpec.TOP, Sizes.dluY(12), FormSpec.NO_GROW),
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(RowSpec.TOP, Sizes.DLUY5, FormSpec.NO_GROW),
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(RowSpec.TOP, Sizes.dluY(12), FormSpec.NO_GROW),
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(RowSpec.TOP, Sizes.DLUY5, FormSpec.NO_GROW),
								new RowSpec("fill:min(default;100dlu)"),
								FormFactory.LINE_GAP_ROWSPEC,
								new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
							}));
						jContentPane.add(jResoureTypeTile, cc.xywh(3, 3, 4, 1));

						//---- jResourceTypeTF ----
						jResourceTypeTF.setBorder(null);
						jResourceTypeTF.setText(bundle.getString("pane.resource.info.jResourceTypeTF.text"));
						jResourceTypeTF.setOpaque(false);
						jResourceTypeTF.setMaximumSize(new Dimension(300, 15));
						jContentPane.add(jResourceTypeTF, cc.xy(5, 5));
						jContentPane.add(jResourceNameTile, cc.xywh(3, 7, 4, 1));

						//---- jResourceNameTF ----
						jResourceNameTF.setBorder(null);
						jResourceNameTF.setText(bundle.getString("pane.resource.info.jResourceNameTF.text"));
						jResourceNameTF.setMaximumSize(new Dimension(300, 15));
						jResourceNameTF.setMinimumSize(new Dimension(24, 15));
						jResourceNameTF.setPreferredSize(new Dimension(100, 15));
						jContentPane.add(jResourceNameTF, cc.xy(5, 9));
						jContentPane.add(jResourceDescTile, cc.xywh(3, 11, 4, 1));

						//---- jResourceDescTA ----
						jResourceDescTA.setTabSize(4);
						jResourceDescTA.setRows(5);
						jResourceDescTA.setBackground(new Color(225, 225, 225));
						jResourceDescTA.setText(bundle.getString("pane.resource.info.jResourceDescTA.text"));
						jResourceDescTA.setMinimumSize(new Dimension(0, 0));
						jResourceDescTA.setWrapStyleWord(true);
						jResourceDescTA.setColumns(10);
						jResourceDescTA.setCaretPosition(1);
						jResourceDescTA.setPreferredSize(new Dimension(0, 0));
						jResourceDescTA.setLineWrap(true);
						jResourceDescTA.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
						jResourceDescTA.setOpaque(false);
						jResourceDescTA.setAutoscrolls(false);
						jResourceDescTA.setEditable(false);
						jContentPane.add(jResourceDescTA, cc.xy(5, 13));
					}
					JContentScrollPane.setViewportView(jContentPane);
				}
				JResourceInfoPaneContentPane.add(JContentScrollPane, cc.xy(1, 1));

				//======== JLinkScrollPane ========
				{
					JLinkScrollPane.setVisible(false);
					JLinkScrollPane.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
					JLinkScrollPane.setOpaque(false);
					JLinkScrollPane.setMinimumSize(new Dimension(80, 22));
					JLinkScrollPane.setPreferredSize(new Dimension(150, 117));

					//======== jLinkContentPane ========
					{
						jLinkContentPane.setPreferredSize(new Dimension(150, 100));
						jLinkContentPane.setMinimumSize(new Dimension(80, 65));
						jLinkContentPane.setMaximumSize(new Dimension(32767, 1000));
						jLinkContentPane.setLayout(new FormLayout(
							new ColumnSpec[] {
								new ColumnSpec(ColumnSpec.LEFT, Sizes.DLUX6, FormSpec.NO_GROW),
								FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
								FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
								FormFactory.RELATED_GAP_COLSPEC,
								FormFactory.UNRELATED_GAP_COLSPEC,
								FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
								new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
								FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
								new ColumnSpec(Sizes.DLUX6)
							},
							new RowSpec[] {
								FormFactory.LINE_GAP_ROWSPEC,
								FormFactory.LINE_GAP_ROWSPEC,
								FormFactory.DEFAULT_ROWSPEC,
								FormFactory.LINE_GAP_ROWSPEC,
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(RowSpec.TOP, Sizes.DLUY5, FormSpec.NO_GROW),
								FormFactory.DEFAULT_ROWSPEC,
								FormFactory.PARAGRAPH_GAP_ROWSPEC,
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(RowSpec.TOP, Sizes.DLUY5, FormSpec.NO_GROW),
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(Sizes.dluY(20)),
								new RowSpec(RowSpec.TOP, Sizes.dluY(12), FormSpec.NO_GROW),
								FormFactory.LINE_GAP_ROWSPEC,
								FormFactory.DEFAULT_ROWSPEC,
								FormFactory.DEFAULT_ROWSPEC,
								FormFactory.PARAGRAPH_GAP_ROWSPEC,
								FormFactory.DEFAULT_ROWSPEC,
								new RowSpec(RowSpec.TOP, Sizes.DLUY5, FormSpec.NO_GROW),
								FormFactory.LINE_GAP_ROWSPEC,
								FormFactory.DEFAULT_ROWSPEC,
								FormFactory.LINE_GAP_ROWSPEC,
								new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
							}));

						//---- goodiesFormsTitle1 ----
						goodiesFormsTitle1.setFont(new Font("Dialog", Font.BOLD, 14));
						jLinkContentPane.add(goodiesFormsTitle1, cc.xywh(4, 3, 5, 1));
						jLinkContentPane.add(jSrcNodeIdTitle, cc.xywh(5, 5, 4, 1));

						//---- jSrcNodeIdTxtFld ----
						jSrcNodeIdTxtFld.setEditable(false);
						jSrcNodeIdTxtFld.setBorder(null);
						jSrcNodeIdTxtFld.setText(bundle.getString("pane.resource.info.jSrcNodeIdTxtFld.text"));
						jSrcNodeIdTxtFld.setOpaque(false);
						jLinkContentPane.add(jSrcNodeIdTxtFld, cc.xy(7, 7));
						jLinkContentPane.add(jSrcNodeNameTitle, cc.xywh(5, 9, 4, 1));

						//---- jSrcNodeNameTxtFld ----
						jSrcNodeNameTxtFld.setEditable(false);
						jSrcNodeNameTxtFld.setBorder(null);
						jSrcNodeNameTxtFld.setText(bundle.getString("pane.resource.info.jSrcNodeNameTxtFld.text"));
						jSrcNodeNameTxtFld.setOpaque(false);
						jLinkContentPane.add(jSrcNodeNameTxtFld, cc.xy(7, 11));

						//---- goodiesFormsTitle2 ----
						goodiesFormsTitle2.setFont(new Font("Dialog", Font.BOLD, 14));
						jLinkContentPane.add(goodiesFormsTitle2, cc.xywh(4, 13, 5, 1));
						jLinkContentPane.add(jTrgtNodeIdTitle, cc.xywh(5, 15, 4, 1));

						//---- jTrgtNodeIdTxtFld ----
						jTrgtNodeIdTxtFld.setEditable(false);
						jTrgtNodeIdTxtFld.setBorder(null);
						jTrgtNodeIdTxtFld.setText(bundle.getString("pane.resource.info.jTrgtNodeIdTxtFld.text"));
						jTrgtNodeIdTxtFld.setOpaque(false);
						jLinkContentPane.add(jTrgtNodeIdTxtFld, cc.xy(7, 16));
						jLinkContentPane.add(jTrgtNodeNameTitle, cc.xywh(5, 18, 4, 1));

						//---- jTrgtNodeNameTxtFld ----
						jTrgtNodeNameTxtFld.setEditable(false);
						jTrgtNodeNameTxtFld.setBorder(null);
						jTrgtNodeNameTxtFld.setOpaque(false);
						jTrgtNodeNameTxtFld.setText(bundle.getString("pane.resource.info.jTrgtNodeNameTxtFld.text"));
						jLinkContentPane.add(jTrgtNodeNameTxtFld, cc.xy(7, 21));
					}
					JLinkScrollPane.setViewportView(jLinkContentPane);
				}
				JResourceInfoPaneContentPane.add(JLinkScrollPane, cc.xy(1, 1));

				//======== JScenScrollPane ========
				{
					JScenScrollPane.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
					JScenScrollPane.setOpaque(false);
					JScenScrollPane.setMinimumSize(new Dimension(80, 22));
					JScenScrollPane.setPreferredSize(new Dimension(150, 117));

					//---- jScenDetailsPane ----
					jScenDetailsPane.setPreferredSize(new Dimension(150, 100));
					jScenDetailsPane.setMinimumSize(new Dimension(80, 65));
					jScenDetailsPane.setMaximumSize(new Dimension(32767, 1000));
					JScenScrollPane.setViewportView(jScenDetailsPane);
				}
				JResourceInfoPaneContentPane.add(JScenScrollPane, cc.xy(1, 1));
			}
			jLeftSplitPane.setLeftComponent(JResourceInfoPane);

			//======== jRightSplitPane ========
			{
				jRightSplitPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
				jRightSplitPane.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
				jRightSplitPane.setDividerLocation(250);
				jRightSplitPane.setResizeWeight(1.0);
				jRightSplitPane.setDividerBorderVisible(false);
				jRightSplitPane.setDividerSize(0);
				jRightSplitPane.setToolTipText(bundle.getString("pane.resource.info.jRightSplitPane.toolTipText"));

				//======== jGraphEditorIFr ========
				{
					jGraphEditorIFr.setTitle("Top");
					jGraphEditorIFr.setContentPaneBorder(null);
					jGraphEditorIFr.setPreferredSize(new Dimension(400, 200));
					jGraphEditorIFr.setFrameIcon(new ImageIcon(getClass().getResource("/images/eclipse/menu/ch_callers.gif")));
					jGraphEditorIFr.setToolBar(JViewToolBar);
					Container jGraphEditorIFrContentPane = jGraphEditorIFr.getContentPane();
					jGraphEditorIFrContentPane.setLayout(new FormLayout(
						"default:grow",
						"default, default, default, default, fill:default:grow"));

					//======== JGraphEditorScrollPane ========
					{
						JGraphEditorScrollPane.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
					}
					jGraphEditorIFrContentPane.add(JGraphEditorScrollPane, cc.xy(1, 5));
				}
				jRightSplitPane.setTopComponent(jGraphEditorIFr);
			}
			jLeftSplitPane.setRightComponent(jRightSplitPane);
		}
		add(jLeftSplitPane, cc.xy(2, 2));

		//======== jResourceToolBar ========
		{
			jResourceToolBar.setEnabled(false);
			jResourceToolBar.setRollover(true);
			jResourceToolBar.setFloatable(false);

			//---- jRICloseBtn ----
			jRICloseBtn.setIcon(new ImageIcon(getClass().getResource("/images/buttons/remove_att.gif")));
			jRICloseBtn.setRolloverIcon(new ImageIcon(getClass().getResource("/images/buttons/delete_obj.gif")));
			jRICloseBtn.setSelectedIcon(null);
			jRICloseBtn.setFocusable(false);
			jRICloseBtn.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jRICloseBtnActionPerformed(e);
				}
			});
			jResourceToolBar.add(jRICloseBtn);
		}

		//======== JViewToolBar ========
		{
			JViewToolBar.setOpaque(false);

			//---- jViewChanger ----
			jViewChanger.setModel(new DefaultComboBoxModel(new String[] {
				"Europe",
				"World Map"
			}));
			jViewChanger.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
			jViewChanger.setFont(new Font("Dialog", Font.PLAIN, 10));
			jViewChanger.setPreferredSize(new Dimension(75, 18));
			jViewChanger.setMinimumSize(new Dimension(75, 16));
			jViewChanger.setMaximumSize(new Dimension(32767, 18));
			jViewChanger.setEnabled(false);
			JViewToolBar.add(jViewChanger);
		}

		//======== jResInfoScrollPaneOLD ========
		{
			jResInfoScrollPaneOLD.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
		}
		// JFormDesigner - End of component initialization//GEN-END:initComponents
    }
    
    private void jRICloseBtnActionPerformed(ActionEvent e) {
        Action resOtlineAction = ActionFactory.getAction(ActionFactory.ACTION_RESOURCE_OUTLINE);
        resOtlineAction.actionPerformed(e);
    }
    
    public JScenarioDetailsPane getJScenDetailsPane() {
        return jScenDetailsPane;
    }
    
	// JFormDesigner - Variables declaration - DO NOT MODIFY//GEN-BEGIN:variables
	// Generated using JFormDesigner non-commercial license
	private UIFSplitPane jLeftSplitPane;
	private SimpleInternalFrame JResourceInfoPane;
	private JScrollPane JContentScrollPane;
	private GenericGradientPane jContentPane;
	private JComponent jResoureTypeTile;
	private JLabel jResourceTypeTF;
	private JComponent jResourceNameTile;
	private JLabel jResourceNameTF;
	private JComponent jResourceDescTile;
	private JTextArea jResourceDescTA;
	private JScrollPane JLinkScrollPane;
	private GenericGradientPane jLinkContentPane;
	private JLabel goodiesFormsTitle1;
	private JComponent jSrcNodeIdTitle;
	private JTextField jSrcNodeIdTxtFld;
	private JComponent jSrcNodeNameTitle;
	private JTextField jSrcNodeNameTxtFld;
	private JLabel goodiesFormsTitle2;
	private JComponent jTrgtNodeIdTitle;
	private JTextField jTrgtNodeIdTxtFld;
	private JComponent jTrgtNodeNameTitle;
	private JTextField jTrgtNodeNameTxtFld;
	private JScrollPane JScenScrollPane;
	private JScenarioDetailsPane jScenDetailsPane;
	private UIFSplitPane jRightSplitPane;
	private SimpleInternalFrame jGraphEditorIFr;
	private JScrollPane JGraphEditorScrollPane;
	private JToolBar jResourceToolBar;
	private JButton jRICloseBtn;
	private JToolBar JViewToolBar;
	private JComboBox jViewChanger;
	private JScrollPane jResInfoScrollPaneOLD;
	// JFormDesigner - End of variables declaration//GEN-END:variables
    
    
    
    
    
    /**
     * Install scenario graph editor in the desktop pane
     * @param scenGraphEditor
     */
    public void addScenarioGraph(ScenarioGraphEditor scenGraphEditor){
        JGraphEditorScrollPane.add(scenGraphEditor);
        JGraphEditorScrollPane.setViewportView(scenGraphEditor.getGraph());
        //layeredPane1.add(scenGraphEditor);
    }
    
    
    /**
     *
     * Appends the specified component to the end of this container.
     * This is a convenience method for {@link #addImpl}.
     * <p>
     * Note: If a component has been added to a container that
     * has been displayed, <code>validate</code> must be
     * called on that container to display the new component.
     * If multiple components are being added, you can improve
     * efficiency by calling <code>validate</code> only once,
     * after all the components have been added.
     *
     * @param     comp   the component to be added
     * @see #addImpl
     * @see #validate
     * @see javax.swing.JComponent#revalidate()
     * @return    the component argument
     */
    public Component add(Component comp) {
        
        JGraphEditorScrollPane.add(comp);
        JGraphEditorScrollPane.setViewportView(comp);
        return comp;
    }
    
    /**
     *
     * Removes the specified component from this container.
     * @param comp the component to be removed
     * @see #add
     */
    public void remove(Component comp) {
        JGraphEditorScrollPane.remove(comp);
    }
    
    
    /**
     * Set title
     * @param title
     */
    public void setTitle(String title, boolean modified){
        if(modified){
            title = "* "+title;
        }
        jGraphEditorIFr.setTitle(title);
    }
    
    //-------------------------------------------------------------------------
    //-------  The Resource Info Helper Methods
    
    public void setResourceOutlineVisible(boolean visible){
        this.JResourceInfoPane.setVisible(visible);
        if(!visible){
            this.lastLeftDividerLocation = jLeftSplitPane.getDividerLocation();
            jLeftSplitPane.setDividerSize(0);
        } else {
            this.jLeftSplitPane.setDividerLocation(lastLeftDividerLocation);
            jLeftSplitPane.setDividerSize(5);
            //this.jLeftSplitPane.validate();
        }
    }
    
    /**
     * Update the observer
     * @param selectedCells the selected cells
     */
    public void update(Object[] selectedCells) {
        log.debug("<update>");
        /*if(!jResInfoScrollPane.isVisible()){
            log.debug("</update: not visible.quit>");
            return;
        }*/
        
        int size = selectedCells != null ? selectedCells.length : 0;
        log.debug("Selection size="+size);
        if(size == 0 || size >1){
            log.debug("disable outline");
            disableResInfoPane();
        } else {
            log.debug("enable outline");
            enableResInfoPane(selectedCells[0]);
        }
        log.debug("</update>");
    }
    
    
    
    
    
    
    private void disableResInfoPane(){
        this.JContentScrollPane.setVisible(false);
        this.JLinkScrollPane.setVisible(false);
        this.JScenScrollPane.setVisible(true);         
    }
    
    private void enableResInfoPane(Object cell){
        
        if(GraphHelper.isGeneric(cell)){
            disableResInfoPane();
            return;
        }
        
        
        if(GraphHelper.isEdge(cell)){
            this.JContentScrollPane.setVisible(false);
            this.JLinkScrollPane.setVisible(true);
            try{
                JGraph graph = ScenarioGraphEditorFactory.getGraphEditorInstance().getGraph();
                Object src = JGraphUtilities.getSourceVertex(graph, cell);
                
                jSrcNodeIdTxtFld.setText(String.valueOf(GraphHelper.getCellObject(src).getResource().getId()));
                jSrcNodeNameTxtFld.setText(GraphHelper.getCellObject(src).getResource().getName());
                
                Object trgt = JGraphUtilities.getTargetVertex(graph, cell);
                jTrgtNodeIdTxtFld.setText(String.valueOf(GraphHelper.getCellObject(trgt).getResource().getId()));
                jTrgtNodeNameTxtFld.setText(GraphHelper.getCellObject(trgt).getResource().getName());
            }catch(Exception e){
                log.error("Exception occured. Details:"+e.getMessage());
                return;
            }
            return;
        }
        
        ScenarioCellObject cellOb = GraphHelper.getCellObject(cell);
                
        jResourceTypeTF.setText(cellOb.getType().getTypeName());
        jResourceNameTF.setText(cellOb.getResource().getName());
        jResourceDescTA.setText(cellOb.getResource().getDescription());
        
        this.JScenScrollPane.setVisible(false);        
        this.JContentScrollPane.setVisible(true);                
    }
    
    public void update(Observable observable, Object obj) {
        log.debug("-- update --");
        // removed Graph 10.1 JGraph graph = ((GraphLayoutCache) observable).getGraph();
        // removed Graph 10.1 update(graph.getSelectionCells());
    }
    
    
    
    
    //-------------------------------------------------------------------------
    //-------  The Message Log Helper Methods
    
    public void setMessageLogVisible(boolean visible){
        msgEventPane.setVisible(visible);
        if(!visible){
            this.lastCenterDividerLocation = jRightSplitPane.getDividerLocation();
            jRightSplitPane.setDividerSize(0);
        } else {
            this.jRightSplitPane.setDividerLocation(lastCenterDividerLocation);
            jRightSplitPane.setDividerSize(5);
        }
    }
    
}
