 /*
  * AddWorkerInternal.java
  *
  * Created on 27 maj 2002, 21:21
  */

package pl.psnc.vlab.ssa.gui.conf;

import java.util.Locale;
import javax.swing.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.ssa.gui.MainFrame;
import pl.psnc.vlab.ssa.util.ImageKeys;
import pl.psnc.vlab.ssa.util.Keys;
import pl.psnc.vlab.ssa.management.SystemConfigurationFactory;
import pl.psnc.vlab.ssa.management.SystemConfigurationValue;
import pl.psnc.vlab.statusbar.StatusBar;
import pl.psnc.vlab.util.image.ImageFactory;
import pl.psnc.vlab.util.swing.gui.Message;


/**
 *
 * @author  Osa
 */
public class SystemConfigurationFrame extends javax.swing.JInternalFrame {
    
    /** Creates Log4j instance */
    private Log cat = LogFactory.getLog(this.getClass().getName() );
    
    
    /** Creates new instance of system configuration frame
     * @param sCV
     */    
    public SystemConfigurationFrame(SystemConfigurationValue sCV) {
        super();
        try{            
            initComponents();
            cat.debug("Default factory ="+Locale.getDefault().getLanguage());
            StatusBar statusBar = MainFrame.getStatusBar();
            statusBar.setMessage(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.title"));
            
            //set icons
            jOK.setIcon(ImageFactory.getImageBean(ImageKeys.ICON_OK).getImage() );
            jCancel.setIcon(ImageFactory.getImageBean(ImageKeys.ICON_CANCEL).getImage()); 
            setFrameIcon(ImageFactory.getImageBean(ImageKeys.ICON_CONFIG).getImage());
            
            //fill fields
            fillFields(sCV);
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        lookAndFeelBG = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jConfTabs = new javax.swing.JTabbedPane();
        jLookAndFeel = new javax.swing.JPanel();
        jBreak4 = new javax.swing.JPanel();
        jUser5 = new javax.swing.JPanel();
        jSilverPane = new javax.swing.JPanel();
        jPanel45 = new javax.swing.JPanel();
        jLabel121 = new javax.swing.JLabel();
        jPanel46 = new javax.swing.JPanel();
        jJavaRB = new javax.swing.JRadioButton();
        jPanel47 = new javax.swing.JPanel();
        jSystemPane = new javax.swing.JPanel();
        jPanel52 = new javax.swing.JPanel();
        jLabel123 = new javax.swing.JLabel();
        jPanel53 = new javax.swing.JPanel();
        jWindowsRB = new javax.swing.JRadioButton();
        jPanel54 = new javax.swing.JPanel();
        jSystemPane1 = new javax.swing.JPanel();
        jPanel55 = new javax.swing.JPanel();
        jLabel124 = new javax.swing.JLabel();
        jPanel56 = new javax.swing.JPanel();
        jKunstStoff = new javax.swing.JRadioButton();
        jPanel57 = new javax.swing.JPanel();
        jSystemPane2 = new javax.swing.JPanel();
        jPanel58 = new javax.swing.JPanel();
        jLabel125 = new javax.swing.JLabel();
        jPanel59 = new javax.swing.JPanel();
        jMotifRB = new javax.swing.JRadioButton();
        jPanel60 = new javax.swing.JPanel();
        jPersonalControl2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jOK = new javax.swing.JButton();
        jCancel = new javax.swing.JButton();

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.X_AXIS));

        setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED), new javax.swing.border.EtchedBorder()));
        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.settings"));
        setAlignmentX(0.0F);
        setAlignmentY(0.0F);
        setMinimumSize(new java.awt.Dimension(600, 200));
        setPreferredSize(new java.awt.Dimension(500, 200));
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameClosed(evt);
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.X_AXIS));

        jPanel1.setMinimumSize(new java.awt.Dimension(359, 230));
        jPanel1.setPreferredSize(new java.awt.Dimension(359, 230));
        jLookAndFeel.setLayout(new java.awt.GridLayout(1, 0));

        jLookAndFeel.setName("t1");
        jBreak4.setLayout(new javax.swing.BoxLayout(jBreak4, javax.swing.BoxLayout.Y_AXIS));

        jUser5.setLayout(new javax.swing.BoxLayout(jUser5, javax.swing.BoxLayout.Y_AXIS));

        jUser5.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.EtchedBorder(), "", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 12)));
        jUser5.setMaximumSize(new java.awt.Dimension(2147483647, 120));
        jUser5.setMinimumSize(new java.awt.Dimension(196, 60));
        jUser5.setPreferredSize(new java.awt.Dimension(220, 120));
        jSilverPane.setLayout(new javax.swing.BoxLayout(jSilverPane, javax.swing.BoxLayout.X_AXIS));

        jSilverPane.setMaximumSize(new java.awt.Dimension(2147483647, 25));
        jSilverPane.setMinimumSize(new java.awt.Dimension(184, 50));
        jSilverPane.setPreferredSize(new java.awt.Dimension(184, 20));
        jPanel45.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel45.setMaximumSize(new java.awt.Dimension(180, 26));
        jPanel45.setMinimumSize(new java.awt.Dimension(180, 26));
        jPanel45.setPreferredSize(new java.awt.Dimension(180, 26));
        jLabel121.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.java.name"));
        jLabel121.setToolTipText("Java");
        jPanel45.add(jLabel121);

        jSilverPane.add(jPanel45);

        jPanel46.setLayout(new javax.swing.BoxLayout(jPanel46, javax.swing.BoxLayout.X_AXIS));

        jPanel46.setMaximumSize(new java.awt.Dimension(2147483647, 21));
        jJavaRB.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.java.val"));
        lookAndFeelBG.add(jJavaRB);
        jJavaRB.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jJavaRBStateChanged(evt);
            }
        });
        jJavaRB.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jJavaRBPropertyChange(evt);
            }
        });

        jPanel46.add(jJavaRB);

        jSilverPane.add(jPanel46);

        jPanel47.setMaximumSize(new java.awt.Dimension(180, 40));
        jPanel47.setMinimumSize(new java.awt.Dimension(180, 40));
        jPanel47.setPreferredSize(new java.awt.Dimension(120, 40));
        jSilverPane.add(jPanel47);

        jUser5.add(jSilverPane);

        jSystemPane.setLayout(new javax.swing.BoxLayout(jSystemPane, javax.swing.BoxLayout.X_AXIS));

        jSystemPane.setMaximumSize(new java.awt.Dimension(2147483647, 25));
        jSystemPane.setMinimumSize(new java.awt.Dimension(184, 50));
        jSystemPane.setPreferredSize(new java.awt.Dimension(184, 20));
        jPanel52.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel52.setMaximumSize(new java.awt.Dimension(180, 26));
        jPanel52.setMinimumSize(new java.awt.Dimension(180, 26));
        jPanel52.setPreferredSize(new java.awt.Dimension(180, 26));
        jLabel123.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.win.name"));
        jLabel123.setToolTipText("Windows");
        jPanel52.add(jLabel123);

        jSystemPane.add(jPanel52);

        jPanel53.setLayout(new javax.swing.BoxLayout(jPanel53, javax.swing.BoxLayout.X_AXIS));

        jPanel53.setMaximumSize(new java.awt.Dimension(2147483647, 21));
        jWindowsRB.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.win.val"));
        jWindowsRB.setToolTipText("");
        lookAndFeelBG.add(jWindowsRB);
        jWindowsRB.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jWindowsRBStateChanged(evt);
            }
        });

        jPanel53.add(jWindowsRB);

        jSystemPane.add(jPanel53);

        jPanel54.setMaximumSize(new java.awt.Dimension(180, 40));
        jPanel54.setMinimumSize(new java.awt.Dimension(180, 40));
        jPanel54.setPreferredSize(new java.awt.Dimension(120, 40));
        jSystemPane.add(jPanel54);

        jUser5.add(jSystemPane);

        jSystemPane1.setLayout(new javax.swing.BoxLayout(jSystemPane1, javax.swing.BoxLayout.X_AXIS));

        jSystemPane1.setMaximumSize(new java.awt.Dimension(2147483647, 25));
        jSystemPane1.setMinimumSize(new java.awt.Dimension(184, 50));
        jSystemPane1.setPreferredSize(new java.awt.Dimension(184, 20));
        jPanel55.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel55.setMaximumSize(new java.awt.Dimension(180, 26));
        jPanel55.setMinimumSize(new java.awt.Dimension(180, 26));
        jPanel55.setPreferredSize(new java.awt.Dimension(180, 26));
        jLabel124.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.kunstoff.name"));
        jLabel124.setToolTipText("KunstStoff");
        jPanel55.add(jLabel124);

        jSystemPane1.add(jPanel55);

        jPanel56.setLayout(new javax.swing.BoxLayout(jPanel56, javax.swing.BoxLayout.X_AXIS));

        jPanel56.setMaximumSize(new java.awt.Dimension(2147483647, 21));
        jKunstStoff.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.kun.val"));
        jKunstStoff.setToolTipText("");
        lookAndFeelBG.add(jKunstStoff);
        jKunstStoff.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jKunstStoffStateChanged(evt);
            }
        });

        jPanel56.add(jKunstStoff);

        jSystemPane1.add(jPanel56);

        jPanel57.setMaximumSize(new java.awt.Dimension(180, 40));
        jPanel57.setMinimumSize(new java.awt.Dimension(180, 40));
        jPanel57.setPreferredSize(new java.awt.Dimension(120, 40));
        jSystemPane1.add(jPanel57);

        jUser5.add(jSystemPane1);

        jSystemPane2.setLayout(new javax.swing.BoxLayout(jSystemPane2, javax.swing.BoxLayout.X_AXIS));

        jSystemPane2.setMaximumSize(new java.awt.Dimension(2147483647, 25));
        jSystemPane2.setMinimumSize(new java.awt.Dimension(184, 50));
        jSystemPane2.setPreferredSize(new java.awt.Dimension(184, 20));
        jPanel58.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel58.setMaximumSize(new java.awt.Dimension(180, 26));
        jPanel58.setMinimumSize(new java.awt.Dimension(180, 26));
        jPanel58.setPreferredSize(new java.awt.Dimension(180, 26));
        jLabel125.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.motif.name"));
        jLabel125.setToolTipText("Motif");
        jPanel58.add(jLabel125);

        jSystemPane2.add(jPanel58);

        jPanel59.setLayout(new javax.swing.BoxLayout(jPanel59, javax.swing.BoxLayout.X_AXIS));

        jPanel59.setMaximumSize(new java.awt.Dimension(2147483647, 21));
        jMotifRB.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.motif.val"));
        jMotifRB.setToolTipText("");
        lookAndFeelBG.add(jMotifRB);
        jMotifRB.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jMotifRBStateChanged(evt);
            }
        });

        jPanel59.add(jMotifRB);

        jSystemPane2.add(jPanel59);

        jPanel60.setMaximumSize(new java.awt.Dimension(180, 40));
        jPanel60.setMinimumSize(new java.awt.Dimension(180, 40));
        jPanel60.setPreferredSize(new java.awt.Dimension(120, 40));
        jSystemPane2.add(jPanel60);

        jUser5.add(jSystemPane2);

        jBreak4.add(jUser5);

        jLookAndFeel.add(jBreak4);

        jConfTabs.addTab(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.skin.tab.name"), jLookAndFeel);

        jPanel1.add(jConfTabs);

        getContentPane().add(jPanel1);

        jPersonalControl2.setLayout(new javax.swing.BoxLayout(jPersonalControl2, javax.swing.BoxLayout.Y_AXIS));

        jPersonalControl2.setMaximumSize(new java.awt.Dimension(50, 12000));
        jPersonalControl2.setMinimumSize(new java.awt.Dimension(50, 120));
        jPersonalControl2.setPreferredSize(new java.awt.Dimension(50, 120));
        jPersonalControl2.add(jPanel3);

        jPanel4.setMaximumSize(new java.awt.Dimension(100, 80));
        jPanel4.setMinimumSize(new java.awt.Dimension(100, 80));
        jPanel4.setPreferredSize(new java.awt.Dimension(100, 80));
        jOK.setMnemonic('z');
        jOK.setToolTipText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.accept.msg"));
        jOK.setMaximumSize(new java.awt.Dimension(30, 30));
        jOK.setMinimumSize(new java.awt.Dimension(30, 30));
        jOK.setPreferredSize(new java.awt.Dimension(30, 30));
        jOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jOKActionPerformed(evt);
            }
        });

        jPanel4.add(jOK);

        jCancel.setMnemonic('c');
        jCancel.setToolTipText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.cancel.msg"));
        jCancel.setMaximumSize(new java.awt.Dimension(30, 30));
        jCancel.setMinimumSize(new java.awt.Dimension(30, 30));
        jCancel.setPreferredSize(new java.awt.Dimension(30, 30));
        jCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCancelActionPerformed(evt);
            }
        });

        jPanel4.add(jCancel);

        jPersonalControl2.add(jPanel4);

        getContentPane().add(jPersonalControl2);

        pack();
    }//GEN-END:initComponents
    
    private void jMotifRBStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jMotifRBStateChanged
        // Add your handling code here:
        try{
            if(jMotifRB.isSelected()){
                //UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
                //updateUI();
            }
        }catch(Exception e){
        }
        
    }//GEN-LAST:event_jMotifRBStateChanged
    
    private void jKunstStoffStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jKunstStoffStateChanged
        // Add your handling code here:
        try{
            if(jKunstStoff.isSelected()){
                //UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
                //UIManager.setLookAndFeel(new com.incors.plaf.kunststoff.KunststoffLookAndFeel());
                //updateUI();
            }
        }catch(Exception e){
        }
    }//GEN-LAST:event_jKunstStoffStateChanged
    
    private void jWindowsRBStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jWindowsRBStateChanged
        // Add your handling code here:\
        try{
            if(jWindowsRB.isSelected()){
                //UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                //updateUI();                
            }
        }catch(Exception e){
        }
    }//GEN-LAST:event_jWindowsRBStateChanged
    
    private void jJavaRBStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jJavaRBStateChanged
        // Add your handling code here:\
        try{
            if(jJavaRB.isSelected()){
                //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
                //updateUI();
            }
        }catch(Exception e){
        }
    }//GEN-LAST:event_jJavaRBStateChanged
    
    private void jJavaRBPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jJavaRBPropertyChange
        // Add your handling code here:
        
    }//GEN-LAST:event_jJavaRBPropertyChange
    
    private void jOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jOKActionPerformed
        // Add your handling code here:
        try{
            //gets data from fields
            SystemConfigurationValue systemConfVO = retrieveFields();
            //serialize data
            SystemConfigurationFactory.setInstance(systemConfVO);
            SystemConfigurationFactory.serializeToFile();
            setVisible(false);
            dispose();
        } catch(java.io.IOException err){
            err.printStackTrace();
            Message.showInfoMessage(this, java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.err.msg"), Message.MESSAGE_TYPE_ERROR);
        } catch(Exception e){
            e.printStackTrace();
            Message.showInfoMessage(this, java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.err.msg") , Message.MESSAGE_TYPE_ERROR);
        }
        
    }//GEN-LAST:event_jOKActionPerformed
    
    private void jCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCancelActionPerformed
        // Add your handling code here:
        SystemConfigurationFactory.setInstance(null);
        setVisible(false);
        dispose();
    }//GEN-LAST:event_jCancelActionPerformed
    
    private void formInternalFrameClosed(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameClosed
        // Add your handling code here:
        MainFrame.getStatusBar().setMessage("");
    }//GEN-LAST:event_formInternalFrameClosed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jBreak4;
    private javax.swing.JButton jCancel;
    private javax.swing.JTabbedPane jConfTabs;
    private javax.swing.JRadioButton jJavaRB;
    private javax.swing.JRadioButton jKunstStoff;
    private javax.swing.JLabel jLabel121;
    private javax.swing.JLabel jLabel123;
    private javax.swing.JLabel jLabel124;
    private javax.swing.JLabel jLabel125;
    private javax.swing.JPanel jLookAndFeel;
    private javax.swing.JRadioButton jMotifRB;
    private javax.swing.JButton jOK;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel45;
    private javax.swing.JPanel jPanel46;
    private javax.swing.JPanel jPanel47;
    private javax.swing.JPanel jPanel52;
    private javax.swing.JPanel jPanel53;
    private javax.swing.JPanel jPanel54;
    private javax.swing.JPanel jPanel55;
    private javax.swing.JPanel jPanel56;
    private javax.swing.JPanel jPanel57;
    private javax.swing.JPanel jPanel58;
    private javax.swing.JPanel jPanel59;
    private javax.swing.JPanel jPanel60;
    private javax.swing.JPanel jPersonalControl2;
    private javax.swing.JPanel jSilverPane;
    private javax.swing.JPanel jSystemPane;
    private javax.swing.JPanel jSystemPane1;
    private javax.swing.JPanel jSystemPane2;
    private javax.swing.JPanel jUser5;
    private javax.swing.JRadioButton jWindowsRB;
    private javax.swing.ButtonGroup lookAndFeelBG;
    // End of variables declaration//GEN-END:variables
    
    
    /** Fills all the fields in the readings configuration frame
     * @param rCV
     */
    private void fillFields(SystemConfigurationValue systemConfVO){
        
        //set L&F
        /*
        String ui = systemConfVO.getLookAndFeel();
        
        if(ui.equals(Keys.LOOK_AND_FEEL_JAVA)) {
            jJavaRB.setSelected(true);
        } else if(ui.equals(Keys.LOOK_AND_FEEL_KUNSTOF)) {
            jKunstStoff.setSelected(true);
        } else if(ui.equals(Keys.LOOK_AND_FEEL_MOTIF)) {
            jMotifRB.setSelected(true);
        } else if(ui.equals(Keys.LOOK_AND_FEEL_WINDOWS)) {
            jWindowsRB.setSelected(true);
        }*/
    }
    
    
    /** Fills all the fields in the readings configuration frame
     * @return
     */
    private SystemConfigurationValue retrieveFields() throws java.io.IOException{
        try{
            SystemConfigurationValue systemConfVO = SystemConfigurationFactory.getInstance();
            //sets L&F
            /*
            if(jJavaRB.isSelected()){
                systemConfVO.setLookAndFeel(Keys.LOOK_AND_FEEL_JAVA);
            } else if(jWindowsRB.isSelected()) {
                systemConfVO.setLookAndFeel(Keys.LOOK_AND_FEEL_WINDOWS);
            } else if(jKunstStoff.isSelected()) {
                systemConfVO.setLookAndFeel(Keys.LOOK_AND_FEEL_KUNSTOF);
            } else if(jMotifRB.isSelected()) {
                systemConfVO.setLookAndFeel(Keys.LOOK_AND_FEEL_MOTIF);
            }*/
            //updateUILook();
            return systemConfVO;
        }catch(Exception e){
            return null;
        }
    }
    
    
    
    
    //--------------------------------------------------------------
    public void updateUILook(){
        //this.updateUI();
        MainFrame main = MainFrame.getInstance();
        java.awt.Frame[] frames = main.getFrames();
        SwingUtilities.updateComponentTreeUI(main);
        main.pack();
        int size = frames.length;
        for(int i=0; i<size; i++){
            SwingUtilities.updateComponentTreeUI(frames[i]);
            frames[i].pack();
        }
    }
    
    
}
