/*
 * Created by JFormDesigner on Thu Jan 12 14:42:59 CET 2006
 */

package pl.psnc.vlab.ssa.gui.event;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;
import com.jgoodies.uif_lite.panel.*;
import java.awt.event.MouseEvent;
import java.util.Locale;
import pl.psnc.vlab.ssa.event.EventLogCellRenderer;
import pl.psnc.vlab.ssa.event.EventLogFactory;
import pl.psnc.vlab.ssa.event.EventLogTableModel;
import pl.psnc.vlab.ssa.gui.MainFrameBase;
import pl.psnc.vlab.ssa.management.SystemConfigurationFactory;
import pl.psnc.vlab.util.i18n.ResourceBundleManager;

/**
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email  osa@man.poznan.pl
 */
public class MsgEventPane extends SimpleInternalFrame {
    
    /** Stores an instance of Main Frame Base */
    private MainFrameBase mainFrameBase;
    
    /** Instance of table model */
    private EventLogTableModel tableModel;
    
    private String[] columnToolTips;
    
    /**
     * Creates new instance of Messge Event Pane
     * @param mainFrameBase
     */
    public MsgEventPane(JPanel mainFrameBase) {
        Locale locale = SystemConfigurationFactory.getInstance().getCurrentLocale();
        ResourceBundleManager bundleMngr = new ResourceBundleManager("pl/psnc/vlab/ssa/event/EventLog", locale);
        columnToolTips = new String[] {
            bundleMngr.getValue("table.header.type"),
                    bundleMngr.getValue("table.header.date"),
                    bundleMngr.getValue("table.header.message"),
                    bundleMngr.getValue("table.header.details") };
                    initComponents();
                    this.mainFrameBase = (MainFrameBase) mainFrameBase;
                    this.tableModel = EventLogFactory.getTableModel();
                    initTable();
    }
    
    private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY//GEN-BEGIN:initComponents
		// Generated using JFormDesigner Evaluation license - Mieszko Ziemowit
		jMsgLogScrollPane = new JScrollPane();
		jMsgLogTable = new JTable() {    
		    //Implement table header tool tips.
		    protected JTableHeader createDefaultTableHeader() {
		        return new JTableHeader(columnModel) {
		            public String getToolTipText(MouseEvent e) {
		                String tip = null;
		                java.awt.Point p = e.getPoint();
		                int index = columnModel.getColumnIndexAtX(p.x);
		                int realIndex = 
		                        columnModel.getColumn(index).getModelIndex();
		                return columnToolTips[realIndex];
		            }
		        };
		    }
		};
		jErrorLogToolBar = new JToolBar();
		jCloseBtn = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setTitle("Message Log");
		setFrameIcon(new ImageIcon(getClass().getResource("/images/buttons/tasks_tsk.gif")));
		setToolBar(jErrorLogToolBar);


		Container contentPane = getContentPane();
		contentPane.setLayout(new FormLayout(
			"default:grow",
			"fill:default:grow"));

		//======== jMsgLogScrollPane ========
		{
			jMsgLogScrollPane.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
			jMsgLogScrollPane.setPreferredSize(new Dimension(200, 200));
			
			//---- jMsgLogTable ----
			jMsgLogTable.setModel(new DefaultTableModel(
				new Object[][] {
					{null, null, null, null},
					{null, null, null, null},
					{null, null, null, null},
					{null, null, null, null},
					{null, null, null, null},
					{null, "", null, ""},
				},
				new String[] {
					" Type", "Date", "Message", "Details"
				}
			) {
				boolean[] columnEditable = new boolean[] {
					false, false, false, false
				};
				public boolean isCellEditable(int rowIndex, int columnIndex) {
					return columnEditable[columnIndex];
				}
			});
			jMsgLogTable.setPreferredScrollableViewportSize(new Dimension(100, 200));
			jMsgLogTable.setPreferredSize(new Dimension(610, 200));
			jMsgLogTable.setMaximumSize(new Dimension(2147483647, 4000));
			jMsgLogTable.setMinimumSize(new Dimension(60, 200));
			jMsgLogTable.setRowMargin(4);
			jMsgLogTable.setRowHeight(18);
			jMsgLogTable.setFocusable(false);
			jMsgLogTable.setRequestFocusEnabled(false);
			jMsgLogScrollPane.setViewportView(jMsgLogTable);
		}
		contentPane.add(jMsgLogScrollPane, cc.xy(1, 1));

		//======== jErrorLogToolBar ========
		{
			jErrorLogToolBar.setEnabled(false);
			jErrorLogToolBar.setRollover(true);
			jErrorLogToolBar.setFloatable(false);
			
			//---- jCloseBtn ----
			jCloseBtn.setIcon(new ImageIcon(getClass().getResource("/images/buttons/remove_att.gif")));
			jCloseBtn.setRolloverIcon(new ImageIcon(getClass().getResource("/images/buttons/delete_obj.gif")));
			jCloseBtn.setSelectedIcon(null);
			jCloseBtn.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jCloseBtnActionPerformed(e);
				}
			});
			jErrorLogToolBar.add(jCloseBtn);
		}
		// JFormDesigner - End of component initialization//GEN-END:initComponents
    }
    
	private void jCloseBtnActionPerformed(ActionEvent e) {
		// TODO add your code here
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY//GEN-BEGIN:variables
	// Generated using JFormDesigner Evaluation license - Mieszko Ziemowit
	private JScrollPane jMsgLogScrollPane;
	private JTable jMsgLogTable;
	private JToolBar jErrorLogToolBar;
	private JButton jCloseBtn;
	// JFormDesigner - End of variables declaration//GEN-END:variables
    
    private void initTable(){
        //set model
        jMsgLogTable.setModel(tableModel);
        //set renderer
        jMsgLogTable.setDefaultRenderer(Object.class, new EventLogCellRenderer(tableModel));
        jMsgLogTable.getTableHeader().setReorderingAllowed(false);
        //set size
        jMsgLogTable.getColumnModel().getColumn(0).setMinWidth(30);
        jMsgLogTable.getColumnModel().getColumn(0).setMaxWidth(60);
        jMsgLogTable.getColumnModel().getColumn(0).setPreferredWidth(40);
        
        jMsgLogTable.getColumnModel().getColumn(1).setMinWidth(130);
        jMsgLogTable.getColumnModel().getColumn(1).setPreferredWidth(140);
        jMsgLogTable.getColumnModel().getColumn(1).setMaxWidth(150);
        
        jMsgLogTable.getColumnModel().getColumn(2).setMinWidth(150);
        jMsgLogTable.getColumnModel().getColumn(2).setPreferredWidth(400);
        jMsgLogTable.getColumnModel().getColumn(2).setMaxWidth(2000);
        
        //jScrollPane1.setViewportView(jLogEventTable);
    }
    
}
