/*
 * LayoutDecorator.java
 *
 * Created on January 30, 2006, 12:44 PM
 *
 */

package pl.psnc.vlab.ssa.gui.layout;

/**
 * Defines the layout decorator which applies the rows and columns templates
 * @author @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email osa@man.poznan.pl
 */
public interface LayoutDecorator {
    
    /**
     * Applies the column template on the given column
     * sepcification
     * @param columnSpecification column specification
     * @return new column specification, after the transformation
     */
    public String applyColumnTemplate(String columnSpecification);
    
    
    /**
     * Applies the row template on the given column
     * sepcification
     * @param rowSpecification row specification
     * @return new row specification, after the transformation
     */
    public String applyRowTemplate(String rowSpecification);
    
}
