/*
 * PaneDecorator.java
 *
 * Created on January 20, 2006, 2:05 PM
 *
 */

package pl.psnc.vlab.ssa.gui.layout;
import pl.psnc.vlab.exception.VlabException;
import pl.psnc.vlab.rds.ElementDocument;
import pl.psnc.vlab.rds.ElementGroupDocument;

/**
 * PaneDecorator class is used to decorate pane
 * @author @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email osa@man.poznan.pl
 */
public interface PaneDecorator {
    
    
    /**
     * Add the resource elements to the given container
     * @param element list of elements
     * @throws pl.psnc.vlab.exception.VlabException 
     */
    public void addElement(ElementDocument.Element element[]) throws VlabException;
    
    
    /**
     * Add the resource group elements to the given container
     * @param elementGroupList list of group element
     * @throws pl.psnc.vlab.exception.VlabException 
     */
    public void addGroupElement(ElementGroupDocument.ElementGroup elementGroupList[]) throws VlabException;
    
    
}
