/*
 * ComponentFactory.java
 *
 * Created on 18 czerwiec 2004, 11:18
 */

package pl.psnc.vlab.ssa.gui.resource;

import pl.psnc.vlab.ssa.gui.resource.components.ElementComponent;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.ssa.gui.resource.components.ErrorElement;
import pl.psnc.vlab.ssa.util.component.ComponentHelper;
import pl.psnc.vlab.xml.ComponentFactory;
//schema
import pl.psnc.vlab.cds.ComponentDocument;
import pl.psnc.vlab.rds.ElementDocument;

/**
 * The Component Factory class is used for creating certain
 * type of components, which represents the resource elements
 * (the properties of the resource elements)
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class ComponentBuilder {
            
    /** Logger instance */
    public static Log log = LogFactory.getLog("pl.psnc.vlab.ssa.gui.resource.ComponentFactory");
    
    /**
     * Create the Java Component which will be able to presetns the
     * resource element properties
     * @param element
     * @return
     */
    public static ElementComponent createComponent(ElementDocument.Element element){
        log.debug("<createComponent name="+element.getName()+">");        
        //get the component type
        ComponentDocument.Component componentType = ComponentFactory.getComponentById( element.getComponent().getId() );
        String componentClass = componentType.getClass1();
        Object component = ComponentHelper.getComponent(componentClass, element);
		component = component == null ? new ErrorElement(element) : component;
        log.debug("</createComponent>");
        return (ElementComponent) component;                 
    }
            
    
}
