/*
 * PropertyDialogFactory.java
 *
 * Created on January 24, 2006, 12:55 PM
 *
 */

package pl.psnc.vlab.ssa.gui.resource;

import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.JDialog;
import javax.swing.JFrame;
import pl.psnc.vlab.exception.VlabException;
import pl.psnc.vlab.rds.ResourceDocument;
import pl.psnc.vlab.ssa.gui.resource.pane.JResourcePropertyDialog;

/**
 * The abstract factory class for Proeprty Dialog creation
 * @author @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email osa@man.poznan.pl
 */
public abstract class PropertyDialogFactory {
    
    
    /**
     * Creates the resource property dialog
     * @param parent
     * @param modal
     * @param resource
     * @return
     */
    public static JDialog getResourcePropertyDialog(JFrame parent, boolean modal, ResourceDocument.Resource resource ) throws VlabException{
        JDialog dialog = new JResourcePropertyDialog(parent, modal, resource);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        dialog.pack();
        Dimension dialogSize = dialog.getSize();
        dialog.setBounds((screenSize.width-dialogSize.width)/2, (screenSize.height-dialogSize.height)/2, dialogSize.width, dialogSize.height);        
        return  dialog;
    }
}