/*
 * TextFieldElement.java
 *
 * Created on 17 czerwiec 2004, 10:53
 */

package pl.psnc.vlab.ssa.gui.resource.components;

import java.awt.Color;
import pl.psnc.vlab.ssa.util.component.ComponentKeys;
import javax.swing.JLabel;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.cds.ComponentDocument;
import pl.psnc.vlab.rds.ElementDocument;
import pl.psnc.vlab.xml.ComponentFactory;

/**
 * This class represents the error message (as a JLabelcomponent). Having the element
 * details specyfied the JLabel component will be configured properly
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class ErrorElement extends ElementComponent{
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /**
     * Creates a new instance of LabelElement, with the
     * element details specyfied by the resource element object
     * @param resourceElement
     */
    public ErrorElement(ElementDocument.Element resourceElement) {
        super(resourceElement);
        elementComponent = new JLabel();
        initElement();
    }
    
    /**
     * Sets the element properties
     */
    protected void initElement(){
        //set element name
        String text = "The specyfied type is not supported.";
        doCast().setToolTipText(text);
        doCast().setText(text);
        doCast().setForeground(Color.red);
    }
    
    /**
     * Cast the element component to the JTextComponent interface
     * @return element component as an JTextComponent
     */
    private JLabel doCast(){
        return (JLabel) elementComponent;
    }
    
    /**
     * Notifies the observers that they should update their data
     */
    public void update() {}
        
        
        
        
        
    }
