/*
 * TextFieldElement.java
 *
 * Created on 17 czerwiec 2004, 10:53
 */

package pl.psnc.vlab.ssa.gui.resource.components;

import com.jgoodies.forms.factories.DefaultComponentFactory;
import pl.psnc.vlab.ssa.util.component.ComponentKeys;
import javax.swing.JLabel;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.cds.ComponentDocument;
import pl.psnc.vlab.rds.ElementDocument;
import pl.psnc.vlab.xml.ComponentFactory;

/**
 * This class represents the JGoodies Form separator component. Having the element
 * details specified the component will be configured properly
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class FormSeparatorElement extends ElementComponent{
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /**
     * Creates a new instance of LabelElement, with the
     * element details specyfied by the resource element object
     * @param resourceElement
     */
    public FormSeparatorElement(ElementDocument.Element resourceElement) {
        super(resourceElement);
        DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
        elementComponent = compFactory.createSeparator(getDisplayName());
        initElement();
    }
    
    /**
     * Sets the element properties
     */
    protected void initElement(){
        //call parent to initialize its components
        super.initElement();        
    }
       
    
    /**
     * Notifies the observers that they should update their data
     * dummy 
     */
    public void update() { }
    
    
}
