/*
 * TextFieldElement.java
 *
 * Created on 17 czerwiec 2004, 10:53
 */

package pl.psnc.vlab.ssa.gui.resource.components;
import javax.swing.JRadioButton;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.rds.ElementDocument;
import pl.psnc.vlab.cds.ItemDocument;
import pl.psnc.vlab.ssa.gui.resource.model.ResourceElementObserver;


/**
 * This class represents the JRadioButton component. Having the element
 * details specyfied the JRadioButton component will be configured properly
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class RadioButtonElement extends ElementAbstractButtonComponent implements ResourceElementObserver{
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /**
     * Creates a new instance of TextFieldElement, with the
     * element details specyfied by the resource element object
     * @param resourceElement
     */
    public RadioButtonElement(ElementDocument.Element resourceElement) {
        super(resourceElement);
        elementComponent = new JRadioButton();
        initElement();
    }
    
    /**
     * Sets the element properties
     */
    protected void initElement(){
        //call parent to initialize its components
        super.initElement();
    }
    
    
    /**
     * Notifies the observer that he has to update his data
     */
    public void update() {
        String value = Boolean.toString(doCast().isSelected());
        log.debug("<update:"+value+">");
        
        ElementDocument.Element.Out out = resourceElement.getOut();
        int itemSize = out.sizeOfItemArray();
        if(itemSize > 1){
            for(int i=itemSize-1; i>0; i--){
                out.removeItem(i);
            }
        }
        ItemDocument.Item outItem = null;
        if(itemSize == 0){
            outItem = out.addNewItem();
        } else {
            outItem = out.getItemArray(0);
        }
        outItem.setId(0);
        outItem.setStringValue(value);
        log.debug("</update>");
    }
    
}
