/*
 * ModelDataListSelectionModel.java
 *
 * Created on 21 czerwiec 2004, 13:04
 */

package pl.psnc.vlab.ssa.gui.resource.model;

import javax.swing.DefaultListSelectionModel;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.cds.ItemDocument;

/**
 *
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class ModelDataListSelectionModel extends DefaultListSelectionModel{
        
    /** Logger instance */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Stores an array of itmes */
    private ItemDocument.Item[] items = null;
    
    /** Stores an array of the selected itmes */
    private ItemDocument.Item[] selectedItems = null;
    
    
    /**
     * Creates new instance of the selection model
     * @param selectedItems
     */    
    public ModelDataListSelectionModel(ItemDocument.Item[] items, ItemDocument.Item[] selectedItems) {
        this.selectedItems = selectedItems;        
        this.items = items;
    }    
    
    
    public void setSelectedItems(){
        log.debug("<setSelectedItems>");
        if(selectedItems == null){
            return;
        }
        int size = this.selectedItems.length;        
        for(int i=0; i<size; i++){
            int index = getIndexByValue(selectedItems[i].getStringValue());
            log.debug("Setting interval to:"+index);            
            addSelectionInterval(index, index);           
            //fireValueChanged(index, index);
        }
        log.debug("Min -"+getMinSelectionIndex());
        log.debug("Max -"+getMaxSelectionIndex());
        
        log.debug("</setSelectedItems>");
    }
    
    private int getIndexByValue(String value){
        int size = items != null ? items.length : 0;
        for(int i=0; i<size; i++){
            if(items[i].getStringValue().equals(value)){
                return i;
            }
        }//end of for
        return -1;
    }
        
}
