/*
 * Created by JFormDesigner on Thu Jan 19 12:36:00 CET 2006
 */

package pl.psnc.vlab.ssa.gui.resource.pane;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;
import com.jgoodies.looks.Options;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.exception.VlabException;
import pl.psnc.vlab.rds.ResourceDocument;
import pl.psnc.vlab.rds.TabDocument;
import pl.psnc.vlab.ssa.actions.ActionFactory;
import pl.psnc.vlab.ssa.gui.resource.components.ElementComponent;
import pl.psnc.vlab.ssa.gui.resource.model.ResourceElementObserver;
import pl.psnc.vlab.ssa.util.component.ResourcePropertyFactory;
import pl.psnc.vlab.tds.TypeDocument;
import pl.psnc.vlab.util.FormTools;
import pl.psnc.vlab.util.image.ImageFactory;
import pl.psnc.vlab.util.swing.gui.*;
import pl.psnc.vlab.xml.ResourceFactory;
import pl.psnc.vlab.xml.TypeFactory;

/**
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email  osa@man.poznan.pl
 */
public class JResourcePropertyDialog extends JDialog implements ResourceElementSubject {
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Stores instacne of the resource value */
    private ResourceDocument.Resource resource = null;
    
    /** Stores the value of the tabbed panes */
    private ArrayList tabPanelList = null;
    
    /** Stores the resource element observers */
    private ArrayList observers = null;
    
    /** Holds value of property invalidComponents. */
    private ArrayList invalidComponents = new ArrayList();
    
    /** Holds value of property components. */
    private Hashtable components = new Hashtable();
    
    
    /**
     * Creates new Resource Property Dialog
     * @param owner
     * @param modal
     * @param resource
     */
    public JResourcePropertyDialog(Frame owner, boolean modal,  ResourceDocument.Resource resource) throws VlabException {
        super(owner, modal);
        initComponents();
        
        //jPropertyTabs.putClientProperty(Options.NO_CONTENT_BORDER_KEY, Boolean.TRUE);
                                
        //get the copy of the resource
        //this.resource = (ResourceDocument.Resource) resource.copy();
        this.resource = ResourceFactory.getResource( ResourceFactory.resourceAsString(resource));
        log.debug("<JResourcePropertyDialog:"+resource.getName()+">");
        //set icons
        //get resource type
        TypeDocument.Type type = TypeFactory.getResourceType(resource.getTypeId());
        if(type != null){
            this.jHTitleIcon.setIcon(ImageFactory.getImageBean(type.getImage().getVertex().getPath() ).getImage());
        }        
        //set dialog name
        this.setTitle(resource.getName());
        this.jHTitleIcon.setToolTipText(resource.getDescription());
        //set obervers array
        this.observers = new ArrayList();
        //add listener
        register(ActionFactory.getAction(ActionFactory.ACTION_SAVE_FILE));
        register(ActionFactory.getAction(ActionFactory.ACTION_SAVE_FILE_AS));
        
        //set property fileds
        setPropertyFields();
    }
    
    
    
    private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY//GEN-BEGIN:initComponents
		// Generated using JFormDesigner non-commercial license
		DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
		jHeaderPane = new GenericGradientPane(ColorKeys.GRADIENT_PANE_HEADER[0], ColorKeys.GRADIENT_PANE_HEADER[1]);
		jHTitleLbl = compFactory.createTitle("Resource Properties");
		jHTitleIcon = new JLabel();
		jHTitleDescLbl = compFactory.createLabel("The dialog presents the list of resource properties");
		jContentPane = new JPanel();
		jPropertyTabs = new JTabbedPane();
		jButtonPane = new JPanel();
		jOkBtn = new JButton();
		jCancelBtn = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setModal(true);
		Container contentPane = getContentPane();
		contentPane.setLayout(new FormLayout(
			ColumnSpec.decodeSpecs("default:grow"),
			new RowSpec[] {
				new RowSpec(RowSpec.FILL, Sizes.dluY(72), FormSpec.NO_GROW),
				FormFactory.LINE_GAP_ROWSPEC,
				new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
				FormFactory.LINE_GAP_ROWSPEC
			}));

		//======== jHeaderPane ========
		{
			jHeaderPane.setBorder(LineBorder.createBlackLineBorder());
			jHeaderPane.setLayout(new FormLayout(
				new ColumnSpec[] {
					FormFactory.UNRELATED_GAP_COLSPEC,
					FormFactory.RELATED_GAP_COLSPEC,
					new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.DEFAULT_COLSPEC,
					FormFactory.DEFAULT_COLSPEC,
					FormFactory.LABEL_COMPONENT_GAP_COLSPEC
				},
				new RowSpec[] {
					FormFactory.PARAGRAPH_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.RELATED_GAP_ROWSPEC,
					new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.NO_GROW),
					FormFactory.LINE_GAP_ROWSPEC,
					new RowSpec(RowSpec.CENTER, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.PARAGRAPH_GAP_ROWSPEC
				}));
			((FormLayout)jHeaderPane.getLayout()).setColumnGroups(new int[][] {{1, 6}});
			jHeaderPane.add(jHTitleLbl, cc.xywh(2, 2, 2, 1));

			//---- jHTitleIcon ----
			jHTitleIcon.setIcon(null);
			jHeaderPane.add(jHTitleIcon, cc.xywh(5, 2, 1, 5));
			jHeaderPane.add(jHTitleDescLbl, cc.xy(3, 4));
		}
		contentPane.add(jHeaderPane, cc.xy(1, 1));

		//======== jContentPane ========
		{
			jContentPane.setPreferredSize(new Dimension(450, 400));
			jContentPane.setMinimumSize(new Dimension(264, 150));
			jContentPane.setLayout(new FormLayout(
				new ColumnSpec[] {
					FormFactory.RELATED_GAP_COLSPEC,
					new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.RELATED_GAP_COLSPEC
				},
				new RowSpec[] {
					new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.PARAGRAPH_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.PARAGRAPH_GAP_ROWSPEC
				}));
			((FormLayout)jContentPane.getLayout()).setColumnGroups(new int[][] {{1, 3}});

			//======== jPropertyTabs ========
			{
				jPropertyTabs.setPreferredSize(new Dimension(300, 60));
			}
			jContentPane.add(jPropertyTabs, cc.xy(2, 1));

			//======== jButtonPane ========
			{
				jButtonPane.setMaximumSize(new Dimension(2147483647, 50));
				jButtonPane.setLayout(new FormLayout(
					new ColumnSpec[] {
						new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
						FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
						FormFactory.BUTTON_COLSPEC,
						FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
						FormFactory.BUTTON_COLSPEC
					},
					RowSpec.decodeSpecs("max(default;25dlu)")));

				//---- jOkBtn ----
				jOkBtn.setText("OK");
				jOkBtn.setIcon(new ImageIcon(getClass().getResource("/images/buttons/ok.gif")));
				jOkBtn.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						jOkBtnActionPerformed(e);
					}
				});
				jButtonPane.add(jOkBtn, cc.xy(3, 1));

				//---- jCancelBtn ----
				jCancelBtn.setText("Cancel");
				jCancelBtn.setIcon(new ImageIcon(getClass().getResource("/images/buttons/delete_obj.gif")));
				jCancelBtn.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						jCancelBtnActionPerformed(e);
					}
				});
				jButtonPane.add(jCancelBtn, cc.xy(5, 1));
			}
			jContentPane.add(jButtonPane, cc.xy(2, 3));
		}
		contentPane.add(jContentPane, cc.xy(1, 3));
		pack();
		setLocationRelativeTo(getOwner());
		// JFormDesigner - End of component initialization//GEN-END:initComponents
    }
    
    private void jOkBtnActionPerformed(ActionEvent e) {
        try{
            //fire observers update
            fireObserverUpdate();
            setVisible(false);
            dispose();
            this.closingCode = JOptionPane.OK_OPTION;
        } catch(Exception err){
            err.printStackTrace();
            Message.showInfoMessage(this, java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.err.msg") , Message.MESSAGE_TYPE_ERROR);
        }
    }
    
    private void jCancelBtnActionPerformed(ActionEvent e) {
        setVisible(false);
        dispose();
        this.closingCode = JOptionPane.CANCEL_OPTION;
    }
    
	// JFormDesigner - Variables declaration - DO NOT MODIFY//GEN-BEGIN:variables
	// Generated using JFormDesigner non-commercial license
	private GenericGradientPane jHeaderPane;
	private JLabel jHTitleLbl;
	private JLabel jHTitleIcon;
	private JLabel jHTitleDescLbl;
	private JPanel jContentPane;
	private JTabbedPane jPropertyTabs;
	private JPanel jButtonPane;
	private JButton jOkBtn;
	private JButton jCancelBtn;
	// JFormDesigner - End of variables declaration//GEN-END:variables
    
    
    
    
    
    /** Fills the data out with the properties
     * from the XML definition file or entered by the user */
    private void setPropertyFields() throws VlabException{
        log.debug("<setPropertyFields>");
        ResourcePropertyFactory propertyFactory = new ResourcePropertyFactory(this, this.resource);
        TabDocument.Tab[] tabList = propertyFactory.getTabList(this.resource);
        int tabSize = tabList != null ? tabList.length : 0;
        log.debug("Tabs count:"+tabSize);
        //create the tab array
        this.tabPanelList = new ArrayList(tabSize);
        for(int i=0; i<tabSize; i++){
            JPanel tabPanel = propertyFactory.getTabPanel(tabList[i], i);
            //save the tab panel
            this.tabPanelList.add(tabPanel);
            //adds the panel to the tabbed pane
            JScrollPane scroll = new JScrollPane(tabPanel);
            scroll.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
            this.jPropertyTabs.add( tabList[i].getDisplayName(), scroll );
        }
        
        
        log.debug("</setPropertyFields>");
    }
    
    /**
     * Tell the subject that you are interested in changes
     * @param o object which is interested in notyfication
     */
    public void register(Object o) {
        this.observers.add(o);
    }
    
    
    /**
     * Get the resource value
     * @return
     */
    public ResourceDocument.Resource getResource(){
        return this.resource;
    }
    
    
    /** Fires the updates events on every registered observer. */
    private void fireObserverUpdate(){
        if( this.observers == null){
            return;
        }
        Iterator it = this.observers.iterator();
        while(it.hasNext()){
            ((ResourceElementObserver) it.next()).update();
        }
    }
    
    public void requestFocus(String name){
        log.debug("<requestFocus: "+name+">");
        if(FormTools.isValidateFormStringNull(name)){
            return;
        }
        Object o = getComponent(name);
        if(o == null){
            return;
        }
        ElementComponent component = (ElementComponent) o;
        int tabIndex = component.getTabIndex();
        log.debug("Tab index="+tabIndex);
        jPropertyTabs.setSelectedIndex(tabIndex);
        component.setBackground(ColorKeys.COLOR_LIGHT_RED);
        component.getConcreteJavaComponent().requestFocus();
        log.debug("</requestFocus>");
    }
    
    /**
     * Getter for property invalidComponents.
     * @return Value of property invalidComponents.
     */
    public ArrayList getInvalidComponents() {
        return this.invalidComponents;
    }
    
    /**
     * Setter for property invalidComponents.
     * @param invalidComponents New value of property invalidComponents.
     */
    public void setInvalidComponents(Component component) {
        this.invalidComponents.add(component);
    }
    
    /**
     * Getter for property components.
     * @return Value of property components.
     */
    public ElementComponent getComponent(String name) {
        return (ElementComponent) this.components.get(name);
    }
    
    /**
     * Setter for property components.
     * @param components New value of property components.
     */
    public void putComponent(String name, ElementComponent component) {
        this.components.put(name, component);
    }

    /**
     * Holds value of property closingCode.
     */
    private int closingCode;

    /**
     * Getter for property closingCode.
     * @return Value of property closingCode.
     */
    public int getClosingCode() {

        return this.closingCode;
    }

    /**
     * Setter for property closingCode.
     * @param closingCode New value of property closingCode.
     */
    public void setClosingCode(int closingCode) {
    }
    
    
}
