/*
 * ResourceElementPanel.java
 *
 * Created on 16 czerwiec 2004, 14:26
 */

package pl.psnc.vlab.ssa.gui.resource.pane;

import javax.swing.JDialog;
import pl.psnc.vlab.ssa.util.component.ComponentKeys;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.rds.ElementDocument;
import pl.psnc.vlab.ssa.gui.resource.ComponentBuilder;
import pl.psnc.vlab.ssa.gui.resource.components.ElementComponent;


/**
 * This panel stores the resource component. The user can fill this
 * component with data
 * @author  Dominik Stoklosa
 */
public class ResourceElementPanel extends javax.swing.JPanel {
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Stores the value of the resource element */
    private ElementDocument.Element element = null;
    
    /** Stores the value of the Resource property Dialog */
    private JResourcePropertyDialog propertyDialog = null;
    
    /** Stores component tab index */
    private int tabIndex;
    
    /** Creates new form ResourceElementPanel */
    public ResourceElementPanel(JDialog propertyDialog, ElementDocument.Element element, int tabIndex) {
        initComponents();
        this.propertyDialog = (JResourcePropertyDialog) propertyDialog;
        this.element = element;
        this.tabIndex = tabIndex;
        fillElement();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLeftPanel = new javax.swing.JPanel();
        jElementName = new javax.swing.JLabel();
        jRightPanel = new javax.swing.JPanel();

        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.X_AXIS));

        jLeftPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 15, 5));

        jElementName.setFont(new java.awt.Font("Verdana", 1, 11));
        jElementName.setText("sample");
        jLeftPanel.add(jElementName);

        add(jLeftPanel);

        jRightPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 10, 10));

        add(jRightPanel);

    }
    // </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jElementName;
    private javax.swing.JPanel jLeftPanel;
    private javax.swing.JPanel jRightPanel;
    // End of variables declaration//GEN-END:variables
    
    private void fillElement(){
        log.debug("<fillElement>");
        //fill the left panel first
        //set element name
        jElementName.setText(element.getDisplayName());
        jElementName.setFont(ComponentKeys.RESOURCE_KEY_FONT);
        log.debug("Adding :"+element.getDisplayName());
        jElementName.setToolTipText(element.getDisplayName());
        jElementName.setEnabled(isEnabled());
        this.setToolTipText(element.getDisplayName());
        //set enabled
        
        //fill the right panel
        ElementComponent component = ComponentBuilder.createComponent(element);
        component.setTabIndex(tabIndex);
        //register component
        propertyDialog.register(component);
        
        this.propertyDialog.putComponent(element.getName(), component);
        jRightPanel.add(component.getConcreteJavaComponent());
        log.debug("</fillElement>");
    }
    
    
}
