/*
 * NmrPropertyDialog.java
 *
 * Created on 17 maj 2004, 13:27
 */

package pl.psnc.vlab.ssa.gui.resource.pane;

import com.jgoodies.looks.Options;
import pl.psnc.vlab.ssa.actions.ActionFactory;
import pl.psnc.vlab.ssa.gui.resource.model.ResourceElementObserver;
import java.awt.Color;
import java.awt.Component;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import javax.swing.JComponent;
import javax.swing.JPanel;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.rds.ResourceDocument;
import pl.psnc.vlab.rds.TabDocument;
import pl.psnc.vlab.ssa.gui.resource.components.ElementComponent;
import pl.psnc.vlab.ssa.util.ImageKeys;
import pl.psnc.vlab.tds.TypeDocument;
import pl.psnc.vlab.util.FormTools;
import pl.psnc.vlab.util.image.ImageFactory;
import pl.psnc.vlab.util.swing.gui.Message;
import pl.psnc.vlab.ssa.util.component.ResourcePropertyFactory;
import pl.psnc.vlab.util.swing.gui.ColorKeys;
import pl.psnc.vlab.xml.ResourceFactory;
import pl.psnc.vlab.xml.TypeFactory;

/**
 *
 * @author  osa
 */
public class ResourcePropertyDialog extends javax.swing.JDialog implements ResourceElementSubject{
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Stores instacne of the resource value */
    private ResourceDocument.Resource resource = null;
    
    /** Stores the value of the tabbed panes */
    private ArrayList tabPanelList = null;
    
    /** Stores the resource element observers */
    private ArrayList observers = null;
    
    /** Holds value of property invalidComponents. */
    private ArrayList invalidComponents = new ArrayList();
    
    /** Holds value of property components. */
    private Hashtable components = new Hashtable();
    
    /** Creates new form NmrPropertyDialog */
    public ResourcePropertyDialog(java.awt.Frame parent, boolean modal,  ResourceDocument.Resource resource)  {
        super(parent, modal);
        initComponents();
        jPropertyTabs.putClientProperty(Options.NO_CONTENT_BORDER_KEY, Boolean.TRUE);
        
        
        jTopPanel.setVisible(false);
        //get the copy of the resource
        //this.resource = (ResourceDocument.Resource) resource.copy();
        this.resource = ResourceFactory.getResource( ResourceFactory.resourceAsString(resource));
        
        
        //set icons
        //get resource type
        TypeDocument.Type type = TypeFactory.getResourceType(resource.getTypeId());
        if(type != null){
            this.jNodeIconLabel.setIcon(ImageFactory.getImageBean(type.getImage().getVertex().getPath() ).getImage());
        }
        jOK.setIcon(ImageFactory.getImageBean(ImageKeys.ICON_OK).getImage());
        jCancel.setIcon(ImageFactory.getImageBean(ImageKeys.ICON_CANCEL).getImage());
        
        //set dialog name
        this.setTitle(resource.getName());
        this.jNodeIconLabel.setToolTipText(resource.getDescription());
        //set obervers array
        this.observers = new ArrayList();
        //add listener
        register(ActionFactory.getAction(ActionFactory.ACTION_SAVE_FILE));
        register(ActionFactory.getAction(ActionFactory.ACTION_SAVE_FILE_AS));
        
        //set property fileds
        //setPropertyFields();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jTopPanel = new javax.swing.JPanel();
        jBottomPanel = new javax.swing.JPanel();
        jTabsPane = new javax.swing.JPanel();
        jPropertyTabs = new javax.swing.JTabbedPane();
        jControlPane = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jNodeIconLabel = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jOK = new javax.swing.JButton();
        jCancel = new javax.swing.JButton();

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        setTitle("");
        setModal(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jTopPanel.setMaximumSize(new java.awt.Dimension(32767, 10));
        getContentPane().add(jTopPanel);

        jBottomPanel.setLayout(new javax.swing.BoxLayout(jBottomPanel, javax.swing.BoxLayout.X_AXIS));

        jTabsPane.setLayout(new javax.swing.BoxLayout(jTabsPane, javax.swing.BoxLayout.X_AXIS));

        jTabsPane.setMinimumSize(new java.awt.Dimension(359, 230));
        jTabsPane.setPreferredSize(new java.awt.Dimension(359, 230));
        jPropertyTabs.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jPropertyTabs.setFocusable(false);
        jPropertyTabs.setFont(new java.awt.Font("Verdana", 0, 12));
        jTabsPane.add(jPropertyTabs);

        jBottomPanel.add(jTabsPane);

        jControlPane.setLayout(new javax.swing.BoxLayout(jControlPane, javax.swing.BoxLayout.Y_AXIS));

        jControlPane.setMaximumSize(new java.awt.Dimension(70, 12000));
        jControlPane.setMinimumSize(new java.awt.Dimension(70, 120));
        jControlPane.setPreferredSize(new java.awt.Dimension(70, 120));
        jPanel3.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 5, 30));

        jNodeIconLabel.setRequestFocusEnabled(false);
        jNodeIconLabel.setOpaque(true);
        jPanel3.add(jNodeIconLabel);

        jControlPane.add(jPanel3);

        jPanel4.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 10, 5));

        jPanel4.setMaximumSize(new java.awt.Dimension(100, 80));
        jPanel4.setMinimumSize(new java.awt.Dimension(100, 80));
        jPanel4.setPreferredSize(new java.awt.Dimension(100, 80));
        jOK.setMnemonic('z');
        jOK.setMaximumSize(new java.awt.Dimension(30, 30));
        jOK.setMinimumSize(new java.awt.Dimension(30, 30));
        jOK.setPreferredSize(new java.awt.Dimension(30, 30));
        jOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jOKActionPerformed(evt);
            }
        });

        jPanel4.add(jOK);

        jCancel.setMnemonic('c');
        jCancel.setMaximumSize(new java.awt.Dimension(30, 30));
        jCancel.setMinimumSize(new java.awt.Dimension(30, 30));
        jCancel.setPreferredSize(new java.awt.Dimension(30, 30));
        jCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCancelActionPerformed(evt);
            }
        });

        jPanel4.add(jCancel);

        jControlPane.add(jPanel4);

        jBottomPanel.add(jControlPane);

        getContentPane().add(jBottomPanel);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-527)/2, (screenSize.height-486)/2, 527, 486);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        log.debug("<formWindowOpened>");
        ArrayList list = getInvalidComponents();
        int size = list != null ? list.size() : 0;
        for(int i=0; i<size; i++){
            JComponent component = (JComponent) list.get(i);
            log.debug("Setting request to "+component.getName());
            component.requestFocusInWindow();
            component.requestFocus();
            component.setBackground(Color.red);
        }
    }//GEN-LAST:event_formWindowOpened
    
    private void jCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCancelActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_jCancelActionPerformed
    
    private void jOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jOKActionPerformed
        try{
            //fire observers update
            fireObserverUpdate();
            setVisible(false);
            dispose();
        } catch(Exception e){
            e.printStackTrace();
            Message.showInfoMessage(this, java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("frame.conf.err.msg") , Message.MESSAGE_TYPE_ERROR);
        }
    }//GEN-LAST:event_jOKActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jBottomPanel;
    private javax.swing.JButton jCancel;
    private javax.swing.JPanel jControlPane;
    private javax.swing.JLabel jNodeIconLabel;
    private javax.swing.JButton jOK;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JTabbedPane jPropertyTabs;
    private javax.swing.JPanel jTabsPane;
    private javax.swing.JPanel jTopPanel;
    // End of variables declaration//GEN-END:variables
    
    
    
    
    /** Fills the data out with the properties
     * from the XML definition file or entered by the user *ResourcePropertyFactoryoid setPropertyFields()ResourcePropertyFactoryebug("<setPropertyFields>");
        PropertyFactory propertyFactory = new PropertyFactory(this, this.resource);
        TabDocument.Tab[] tabList = propertyFactory.getTabList(this.resource);
        int tabSize = tabList != null ? tabList.length : 0;
        log.debug("Tabs count:"+tabSize);
        //create the tab array
        this.tabPanelList = new ArrayList(tabSize);
        for(int i=0; i<tabSize; i++){
            JPanel tabPanel = propertyFactory.getTabPanel(tabList[i], i);
            //save the tab panel
            this.tabPanelList.add(tabPanel);
            //adds the panel to the tabbed pane
            this.jPropertyTabs.add( tabList[i].getDisplayName(), tabPanel );
        }
        
        
        log.debug("</setPropertyFields>");
    }
    
    /**
     * Tell the subject that you are interested in changes
     * @param o object which is interested in notyfication
     */
    public void register(Object o) {
        this.observers.add(o);
    }
    
    
    /**
     * Get the resource value
     * @return
     */
    public ResourceDocument.Resource getResource(){
        return this.resource;
    }
    
    
    /** Fires the updates events on every registered observer. */
    private void fireObserverUpdate(){
        if( this.observers == null){
            return;
        }
        Iterator it = this.observers.iterator();
        while(it.hasNext()){
            ((ResourceElementObserver) it.next()).update();
        }
    }
    
    public void requestFocus(String name){
        log.debug("<requestFocus: "+name+">");
        if(FormTools.isValidateFormStringNull(name)){
            return;
        }
        Object o = getComponent(name);
        if(o == null){
            return;
        }
        ElementComponent component = (ElementComponent) o;
        jPropertyTabs.setSelectedIndex(component.getTabIndex());
        component.getConcreteJavaComponent().setBackground(ColorKeys.COLOR_LIGHT_RED);
        component.getConcreteJavaComponent().requestFocus();
    }
    
    /**
     * Getter for property invalidComponents.
     * @return Value of property invalidComponents.
     */
    public ArrayList getInvalidComponents() {
        return this.invalidComponents;
    }
    
    /**
     * Setter for property invalidComponents.
     * @param invalidComponents New value of property invalidComponents.
     */
    public void setInvalidComponents(Component component) {
        this.invalidComponents.add(component);
    }
    
    /**
     * Getter for property components.
     * @return Value of property components.
     */
    public ElementComponent getComponent(String name) {
        return (ElementComponent) this.components.get(name);
    }
    
    /**
     * Setter for property components.
     * @param components New value of property components.
     */
    public void putComponent(String name, ElementComponent component) {
        this.components.put(name, component);
    }
    
}
