/*
 * SzdBrowserPane.java
 *
 * Created on 10 listopad 2004, 11:02
 */

package pl.psnc.vlab.ssa.gui.resource.pane;

import java.awt.Frame;
import javax.swing.JList;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.ssa.gui.resource.model.SzdNodeElementListModel;
import pl.psnc.vlab.szdbrowser.gui.NodeChooser;
import pl.psnc.vlab.szdbrowser.gui.selectedlist.NodeValue;


/**
 *
 * @author  Dominik Stoklosa
 */
public class SzdBrowserPane extends javax.swing.JPanel {
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Stores an instance of the szd browser */
    private NodeChooser szdBrowser;
    
    /** Stores an instance of parent frame */
    private Frame parentFrame;
    
    /** Stores an instance of the certificateId */
    private String certificateId;
    
    /** Stores an instance of the user proxy */
    private byte[] proxy;
    
    /** Stores an instance of the selected ids */
    private int selectedIds[];
    
    /**
     * Creates new form SzdBrowserPane
     * @param parentFrame
     * @param certificateId
     * @param proxy
     * @param selectedIds
     */
    public SzdBrowserPane(Frame parentFrame, String certificateId, byte proxy[], int selectedIds[]) {
        initComponents();
        this.parentFrame = parentFrame;
        this.certificateId = certificateId;
        this.proxy = proxy;
        this.selectedIds = selectedIds;
        log.debug("certificateId-"+certificateId);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jBrowseBtn = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jSelectionList = new javax.swing.JList();

        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.Y_AXIS));

        setPreferredSize(new java.awt.Dimension(200, 132));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMaximumSize(new java.awt.Dimension(100, 40));
        jPanel1.setPreferredSize(new java.awt.Dimension(100, 40));
        jBrowseBtn.setFont(new java.awt.Font("Verdana", 0, 11));
        jBrowseBtn.setText(java.util.ResourceBundle.getBundle("bundle/dynamicScenario").getString("szd.browser.browse.btn"));
        jBrowseBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBrowseBtnActionPerformed(evt);
            }
        });

        jPanel1.add(jBrowseBtn, new java.awt.GridBagConstraints());

        add(jPanel1);

        jScrollPane1.setAutoscrolls(true);
        jScrollPane1.setPreferredSize(new java.awt.Dimension(200, 132));
        jSelectionList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(jSelectionList);

        add(jScrollPane1);

    }
    // </editor-fold>//GEN-END:initComponents
    
    private void jBrowseBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBrowseBtnActionPerformed
        initChooser();
        szdBrowser.show();
        updateSelection();
        
    }//GEN-LAST:event_jBrowseBtnActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBrowseBtn;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList jSelectionList;
    // End of variables declaration//GEN-END:variables
    
    /**
     * Update selection
     * @return
     */
    public void updateSelection(){
        log.debug("<updateSelection>");
        if(szdBrowser.getUserChoice() == NodeChooser.CANCEL){
            log.debug("</updateSelection:CANCEL>");
            return;
        }
        NodeValue list[] = this.szdBrowser.getSelectedNodes();
        SzdNodeElementListModel listModel = (SzdNodeElementListModel) jSelectionList.getModel();
        listModel.updateModel(list);
    }
    
    /**
     * Get the selection list
     * @return
     */
    public JList getSelectionList(){
        return this.jSelectionList ;
    }
    
    public void setName(String str) {
        super.setName(str);
        jSelectionList.setName(str);
    }
    
    public void setToolTipText(String str) {
        super.setToolTipText(str);
        jScrollPane1.setToolTipText(str);
        jSelectionList.setToolTipText(str);
    }
    
    public void setEnabled(boolean param) {
        super.setEnabled(param);
        jSelectionList.setEnabled(param);
    }
    
    public void setVisible(boolean param) {
        super.setVisible(param);
        jSelectionList.setVisible(param);
    }
    
    
    
    
    /**
     * Set selected ids
     * @param ids
     */
    public void setSelectedIds(int ids[]){
        this.selectedIds = ids;
    }
    
    private void initChooser(){
        int items[] = ( (SzdNodeElementListModel)jSelectionList.getModel()).getModelDataAsIntArray();
        int itemsSize = items != null ? items.length : 0;
        if(itemsSize == 0){
            items = selectedIds;
            log.debug("Items list null");
        }
        itemsSize = items != null ? items.length : 0;
        log.debug("Items size -"+itemsSize);
        for(int i=0; i<itemsSize; i++){
            log.debug("Item="+items[i]);
        }
        if(itemsSize != 0){
            this.szdBrowser = new NodeChooser(parentFrame, true, items, certificateId, proxy);
        } else {
            this.szdBrowser = new NodeChooser(parentFrame, true, certificateId, proxy);
        }
        
    }
    
    public void setFont(java.awt.Font font) {
        super.setFont(font);
        if(jSelectionList != null){
            jSelectionList.setFont(font);
        }
    }
    
}
