/*
 * Created by JFormDesigner on Fri Feb 03 11:55:17 CET 2006
 */

package pl.psnc.vlab.ssa.gui.scenario;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;
import javax.swing.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.rds.ScenarioDocument;
import pl.psnc.vlab.ssa.actions.ActionFactory;
import pl.psnc.vlab.util.FormTools;
import pl.psnc.vlab.util.swing.gui.ColorKeys;
import pl.psnc.vlab.util.swing.gui.GenericGradientPane;


/**
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email  osa@man.poznan.pl
 */
public class JScenarioDetailsPane extends GenericGradientPane implements Observer{
    
    /** Instance of logger */
    private  Log log = LogFactory.getLog(getClass().getName());
    
    
    /** Instance of the scenario description */
    private ScenarioDocument.Scenario scenario;
    
    /**
     * Creates new Scenario Details Pane (Part of Resource Info Perspective)
     */
    public JScenarioDetailsPane() {
        initComponents();
    }
    
    /**
     * Creates new Scenario Details Pane (Part of Resource Info Perspective)
     * @param scenario scenario details
     */
    public JScenarioDetailsPane(ScenarioDocument.Scenario scenario) {
        super(ColorKeys.GRADIENT_LIGHT_GRAY_AND_WHITE[1], ColorKeys.GRADIENT_LIGHT_GRAY_AND_WHITE[0]);
        initComponents();
        this.scenario = scenario;
        setFields();        //fill scenario properties
    }
    
    private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY//GEN-BEGIN:initComponents
		// Generated using JFormDesigner non-commercial license
		ResourceBundle bundle = ResourceBundle.getBundle("pl.psnc.vlab.ssa.gui.scenario.ScenarioDetailPane");
		DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
		jContentNotAvailPane = new JPanel();
		jScenDetailsTitle = compFactory.createSeparator(bundle.getString("scen.details.pane.jScenDetailsTitle.text"));
		jDetailsNotDefLbl = compFactory.createLabel(bundle.getString("scen.details.pane.jDetailsNotDefLbl.textWithMnemonic"));
		jSectionSepTitle = compFactory.createSeparator("");
		jOpenPropertiesSepTitle = compFactory.createSeparator(bundle.getString("scen.details.pane.jOpenPropertiesSepTitle.text"));
		jNewScenPropertiesBtn = new JButton();
		jContentPane = new JPanel();
		jScenNameTitle = compFactory.createSeparator(bundle.getString("scen.details.pane.jScenNameTitle.text"));
		jScenNameVal = new JTextField();
		jScenDescTitle = compFactory.createSeparator(bundle.getString("scen.details.pane.jScenDescTitle.text"));
		jScenDescVal = new JTextArea();
		jScenCreatedByTitle = compFactory.createSeparator(bundle.getString("scen.details.pane.jScenCreatedByTitle.text"));
		jScenModifiedByVal = new JTextField();
		jLinkSectionTitle = compFactory.createSeparator("");
		jScenPropertiesBtn = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setPreferredSize(new Dimension(200, 300));
		setLayout(new FormLayout(
			"default:grow",
			"fill:default:grow"));

		//======== jContentNotAvailPane ========
		{
			jContentNotAvailPane.setPreferredSize(new Dimension(200, 300));
			jContentNotAvailPane.setOpaque(false);
			jContentNotAvailPane.setLayout(new FormLayout(
				new ColumnSpec[] {
					FormFactory.UNRELATED_GAP_COLSPEC,
					FormFactory.RELATED_GAP_COLSPEC,
					new ColumnSpec(ColumnSpec.FILL, Sizes.MINIMUM, FormSpec.DEFAULT_GROW),
					new ColumnSpec(ColumnSpec.RIGHT, Sizes.PREFERRED, FormSpec.NO_GROW),
					FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
					FormFactory.UNRELATED_GAP_COLSPEC
				},
				new RowSpec[] {
					FormFactory.UNRELATED_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.LINE_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					new RowSpec("fill:min(default;20dlu):grow(0.1)"),
					FormFactory.DEFAULT_ROWSPEC,
					new RowSpec("fill:min(default;20dlu):grow(0.1)"),
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.RELATED_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
				}));
			((FormLayout)jContentNotAvailPane.getLayout()).setColumnGroups(new int[][] {{1, 6}});
			jSectionSepTitle.setForeground(Color.orange);

			//---- jScenDetailsTitle ----
			jLinkSectionTitle.setForeground(Color.orange);
			jContentNotAvailPane.add(jScenDetailsTitle, cc.xywh(2, 2, 3, 1));
			jContentNotAvailPane.add(jDetailsNotDefLbl, cc.xywh(3, 4, 2, 1));
			jContentNotAvailPane.add(jSectionSepTitle, cc.xywh(2, 6, 4, 1));
			jContentNotAvailPane.add(jOpenPropertiesSepTitle, cc.xywh(2, 8, 3, 1));

			//---- jNewScenPropertiesBtn ----
			jNewScenPropertiesBtn.setText(bundle.getString("scen.details.pane.jNewScenPropertiesBtn.text"));
			jNewScenPropertiesBtn.setIcon(new ImageIcon(getClass().getResource("/images/eclipse/menu/segment_edit.gif")));
			jNewScenPropertiesBtn.setToolTipText(bundle.getString("scen.details.pane.jNewScenPropertiesBtn.toolTipText"));
			jNewScenPropertiesBtn.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jNewScenPropertiesBtnActionPerformed(e);
				}
			});
			jContentNotAvailPane.add(jNewScenPropertiesBtn, cc.xy(4, 10));
		}
		add(jContentNotAvailPane, cc.xy(1, 1));

		//======== jContentPane ========
		{
			jContentPane.setPreferredSize(new Dimension(200, 300));
			jContentPane.setOpaque(false);
			jContentPane.setVisible(false);
			jContentPane.setLayout(new FormLayout(
				new ColumnSpec[] {
					FormFactory.UNRELATED_GAP_COLSPEC,
					FormFactory.RELATED_GAP_COLSPEC,
					new ColumnSpec(ColumnSpec.FILL, Sizes.MINIMUM, FormSpec.DEFAULT_GROW),
					new ColumnSpec(ColumnSpec.CENTER, Sizes.dluX(50), FormSpec.NO_GROW),
					FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
					FormFactory.UNRELATED_GAP_COLSPEC
				},
				new RowSpec[] {
					FormFactory.UNRELATED_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.LINE_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					new RowSpec("fill:min(default;20dlu):grow(0.1)"),
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.RELATED_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					new RowSpec("fill:min(default;20dlu):grow(0.1)"),
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.RELATED_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					new RowSpec("fill:min(default;20dlu):grow"),
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.UNRELATED_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.UNRELATED_GAP_ROWSPEC
				}));
			((FormLayout)jContentPane.getLayout()).setColumnGroups(new int[][] {{1, 6}});
			jContentPane.add(jScenNameTitle, cc.xywh(2, 2, 4, 1));

			//---- jScenNameVal ----
			jScenNameVal.setEditable(false);
			jScenNameVal.setOpaque(false);
			jScenNameVal.setText("name");
			jScenNameVal.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
			jContentPane.add(jScenNameVal, cc.xywh(3, 4, 2, 1));
			jContentPane.add(jScenDescTitle, cc.xywh(2, 6, 4, 1));

			//---- jScenDescVal ----
			jScenDescVal.setColumns(10);
			jScenDescVal.setRows(4);
			jScenDescVal.setText("desc");
			jScenDescVal.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
			jScenDescVal.setOpaque(false);
			jContentPane.add(jScenDescVal, cc.xywh(3, 8, 2, 1));
			jContentPane.add(jScenCreatedByTitle, cc.xywh(2, 10, 4, 1));

			//---- jScenModifiedByVal ----
			jScenModifiedByVal.setEditable(false);
			jScenModifiedByVal.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
			jScenModifiedByVal.setOpaque(false);
			jScenModifiedByVal.setText("autor");
			jContentPane.add(jScenModifiedByVal, cc.xywh(3, 12, 2, 1));

			//---- jLinkSectionTitle ----
			jLinkSectionTitle.setForeground(Color.orange);
			jContentPane.add(jLinkSectionTitle, cc.xywh(2, 14, 4, 1));

			//---- jScenPropertiesBtn ----
			jScenPropertiesBtn.setText(bundle.getString("scen.details.pane.jScenPropertiesBtn.text"));
			jScenPropertiesBtn.setIcon(new ImageIcon(getClass().getResource("/images/eclipse/menu/segment_edit.gif")));
			jScenPropertiesBtn.setToolTipText(bundle.getString("scen.details.pane.jScenPropertiesBtn.toolTipText"));
			jScenPropertiesBtn.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jScenPropertiesBtnActionPerformed(e);
				}
			});
			jContentPane.add(jScenPropertiesBtn, cc.xywh(4, 16, 2, 1));
		}
		add(jContentPane, cc.xy(1, 1));
		// JFormDesigner - End of component initialization//GEN-END:initComponents
    }
    
    private void jScenPropertiesBtnActionPerformed(ActionEvent e) {
        ActionFactory.getAction(ActionFactory.ACTION_SCENARIO_PROPERTIES).actionPerformed(e);
    }
    
    private void jNewScenPropertiesBtnActionPerformed(ActionEvent e) {
        ActionFactory.getAction(ActionFactory.ACTION_SCENARIO_PROPERTIES).actionPerformed(e);
    }
    
    private void jScenNameValPropertyChange(PropertyChangeEvent e) {
        
    }
    
	// JFormDesigner - Variables declaration - DO NOT MODIFY//GEN-BEGIN:variables
	// Generated using JFormDesigner non-commercial license
	private JPanel jContentNotAvailPane;
	private JComponent jScenDetailsTitle;
	private JLabel jDetailsNotDefLbl;
	private JComponent jSectionSepTitle;
	private JComponent jOpenPropertiesSepTitle;
	private JButton jNewScenPropertiesBtn;
	private JPanel jContentPane;
	private JComponent jScenNameTitle;
	private JTextField jScenNameVal;
	private JComponent jScenDescTitle;
	private JTextArea jScenDescVal;
	private JComponent jScenCreatedByTitle;
	private JTextField jScenModifiedByVal;
	private JComponent jLinkSectionTitle;
	private JButton jScenPropertiesBtn;
	// JFormDesigner - End of variables declaration//GEN-END:variables
    
    
    /** Set the frame fields to the values from the ScenarioDocument
     */
    private void setFields(){
        if(scenario == null || FormTools.isValidateFormStringNull(scenario.getName())){
            setScenarioProperties(false);
            return;
        }
        setScenarioProperties(true);
        jScenNameVal.setText( scenario.getName());                            //set name
        jScenDescVal.setText( scenario.getDescription());                     //set description
        jScenModifiedByVal.setText( scenario.getModifiedBy());              //set modified by
    }
    
    private void setScenarioProperties(boolean visible){
        jContentNotAvailPane.setVisible(!visible);
        jContentPane.setVisible(visible);
    }
    
    public void update(Observable observable, Object obj) {
        log.debug("Update");
        this.scenario = (ScenarioDocument.Scenario) obj;
        setFields();
    }
    
    
    
}
