/*
 * Created by JFormDesigner on Fri Mar 03 14:15:42 CET 2006
 */

package pl.psnc.vlab.ssa.gui.scenario;

import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.exception.VlabException;
import pl.psnc.vlab.psc.ScenarioDocument;
import pl.psnc.vlab.ssa.actions.AbstractActionDefault;
import pl.psnc.vlab.ssa.actions.ActionFactory;
import pl.psnc.vlab.util.FormTools;
import pl.psnc.vlab.util.i18n.ResourceBundleManager;
import pl.psnc.vlab.util.image.ImageFactory;
import pl.psnc.vlab.util.swing.gui.Message;

/**
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email  osa@man.poznan.pl
 */
public class JScenarioWPane extends JPanel {
    
    private final static String MISSING_DESC_KEY = "missing.value.key";
    
    /** Specifies the Open Sample Scenario Action */
    public final static String ACTION_CMD_OPEN_SAMPE = "open.sample.scenario";
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    
    /** Stores an instance of the scenario xml description */
    private ScenarioDocument.Scenario scenario;
    
    
    /** Stores an instance of the Scenario Wizard Dialog */
    private JDialog parent;
    
    
    public JScenarioWPane(JDialog parentDialog, ScenarioDocument.Scenario scenario, ResourceBundleManager bundle) throws VlabException{
        this.parent = parentDialog;
        this.scenario = scenario;
        initComponents();
        jScenOpenBtn.setActionCommand(ACTION_CMD_OPEN_SAMPE);
        initScenario(scenario, bundle);
    }
    
    private void jScenOpenBtnActionPerformed(ActionEvent e) {
        try{
            AbstractActionDefault openAction = ActionFactory.getAction(ActionFactory.ACTION_OPEN_FILE);
            log.debug("ActionC="+e.getActionCommand());
            e.setSource(scenario);
            parent.setVisible(false);
            openAction.actionPerformed(e);            
        }catch(Exception err){
            err.printStackTrace();
            //tbd i14n
            Message.showInfoMessage(parent, "Error during loading sample scenario. Details:"+ err.getMessage(), Message.MESSAGE_TYPE_ERROR);
        }
        
    }
    
    private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY//GEN-BEGIN:initComponents
		// Generated using JFormDesigner Evaluation license - Vlab Vlab
		ResourceBundle bundle = ResourceBundle.getBundle("pl.psnc.vlab.ssa.gui.scenario.ScenarioWPane");
		DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
		jScenIconLbl = compFactory.createLabel("");
		jScenNameSep = compFactory.createSeparator(bundle.getString("JScenarioWPane.jScenNameSep.text"));
		jScenNameLbl = new JLabel();
		jScenDescSep = compFactory.createSeparator(bundle.getString("JScenarioWPane.jScenDescSep.text"));
		jScenDescLbl = new JLabel();
		jScenOpenSep = compFactory.createSeparator(bundle.getString("JScenarioWPane.jScenOpenSep.text"));
		jScenOpenBtn = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setOpaque(false);

		// JFormDesigner evaluation mark
		setBorder(new javax.swing.border.CompoundBorder(
			new javax.swing.border.TitledBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0),
				"JFormDesigner Evaluation", javax.swing.border.TitledBorder.CENTER,
				javax.swing.border.TitledBorder.BOTTOM, new java.awt.Font("Dialog", java.awt.Font.BOLD, 12),
				java.awt.Color.red), getBorder())); addPropertyChangeListener(new java.beans.PropertyChangeListener(){public void propertyChange(java.beans.PropertyChangeEvent e){if("border".equals(e.getPropertyName()))throw new RuntimeException();}});

		setLayout(new FormLayout(
			new ColumnSpec[] {
				FormFactory.RELATED_GAP_COLSPEC,
				FormFactory.DEFAULT_COLSPEC,
				FormFactory.UNRELATED_GAP_COLSPEC,
				FormFactory.RELATED_GAP_COLSPEC,
				FormFactory.DEFAULT_COLSPEC,
				FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
				new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
				FormFactory.UNRELATED_GAP_COLSPEC,
				FormFactory.PREF_COLSPEC,
				FormFactory.DEFAULT_COLSPEC
			},
			new RowSpec[] {
				FormFactory.DEFAULT_ROWSPEC,
				FormFactory.DEFAULT_ROWSPEC,
				FormFactory.LINE_GAP_ROWSPEC,
				FormFactory.DEFAULT_ROWSPEC,
				FormFactory.UNRELATED_GAP_ROWSPEC,
				FormFactory.DEFAULT_ROWSPEC,
				FormFactory.LINE_GAP_ROWSPEC,
				FormFactory.DEFAULT_ROWSPEC,
				FormFactory.UNRELATED_GAP_ROWSPEC,
				FormFactory.UNRELATED_GAP_ROWSPEC,
				FormFactory.DEFAULT_ROWSPEC,
				FormFactory.LINE_GAP_ROWSPEC,
				FormFactory.DEFAULT_ROWSPEC
			}));

		//---- jScenIconLbl ----
		jScenIconLbl.setIcon(new ImageIcon("/home/osa/cvs/sources/dynamicScenario/src/images/graph/Chemical_enabledS.gif"));
		add(jScenIconLbl, cc.xywh(2, 2, 1, 3));
		add(jScenNameSep, cc.xywh(4, 2, 6, 1));
		add(jScenNameLbl, cc.xywh(5, 4, 5, 1));
		add(jScenDescSep, cc.xywh(4, 6, 6, 1));
		add(jScenDescLbl, cc.xywh(5, 8, 5, 1));
		add(jScenOpenSep, cc.xywh(2, 11, 6, 1));

		//---- jScenOpenBtn ----
		jScenOpenBtn.setIcon(new ImageIcon("/home/osa/cvs/sources/dynamicScenario/src/images/eclipse/menu/arrowGreen.gif"));
		jScenOpenBtn.setHorizontalTextPosition(SwingConstants.LEADING);
		jScenOpenBtn.setToolTipText(bundle.getString("JScenarioWPane.jScenOpenBtn.toolTipText"));
		jScenOpenBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jScenOpenBtnActionPerformed(e);
			}
		});
		add(jScenOpenBtn, cc.xy(9, 11));
		// JFormDesigner - End of component initialization//GEN-END:initComponents
    }
    
	// JFormDesigner - Variables declaration - DO NOT MODIFY//GEN-BEGIN:variables
	// Generated using JFormDesigner Evaluation license - Vlab Vlab
	private JLabel jScenIconLbl;
	private JComponent jScenNameSep;
	private JLabel jScenNameLbl;
	private JComponent jScenDescSep;
	private JLabel jScenDescLbl;
	private JComponent jScenOpenSep;
	private JButton jScenOpenBtn;
	// JFormDesigner - End of variables declaration//GEN-END:variables
    
    
    //--------------------------------------------------------------------------
    //----- Private, internal helper methods
    
    
    /**
     * Set scenario properties (name, description, icon, etc.)
     *
     * @return new scenario
     * @param bundle
     * @param scenario
     * @throws VlabException
     */
    private JComponent initScenario(ScenarioDocument.Scenario scenario, ResourceBundleManager bundle) throws VlabException{
        try{
            String name = bundle.getValue(scenario.getName());
            log.debug("<setScenario name="+name);
            jScenNameLbl.setText(name);     //set name
            this.setName(name);
            String desc = bundle.getValue(scenario.getDescription());
            if(FormTools.isValidateFormStringNull(desc)){
                desc = bundle.getValue(MISSING_DESC_KEY);
            }
            jScenDescLbl.setText(desc);
            
            jScenIconLbl.setIcon(ImageFactory.getImageBean(scenario.getIcon()).getImage() );    //set icon
            setToolTipText(desc);          //set tooltip
            /*
             
            //add mouse events handlers
            jLabel.addMouseListener(new MouseAdapter() {
             
                public void mouseEntered(MouseEvent e) {
                    jScenMouseEntered(e);
                }
                public void mouseExited(MouseEvent e) {
                    jScenMouseExited(e);
                }
                public void mousePressed(MouseEvent e) {
                    //jMousePressed(e);
                }
            });
             */
            log.debug("</appendScenario>");
            return this;
        }catch(Exception err){
            log.debug("</appendScenario:err>");
            throw new VlabException("Error initializnig scenario.", err);
        }
    }
}
