/*
 * Created by JFormDesigner on Fri Feb 17 14:21:41 CET 2006
 */

package pl.psnc.vlab.ssa.gui.scenario;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.factories.DefaultComponentFactory;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.FormSpec;
import com.jgoodies.forms.layout.RowSpec;
import com.jgoodies.forms.layout.Sizes;
import com.jgoodies.uif_lite.panel.SimpleInternalFrame;
import java.awt.Color;
import java.awt.event.MouseEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.HashMap;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.border.LineBorder;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.exception.VlabException;
import pl.psnc.vlab.psc.CategoryDocument;
import pl.psnc.vlab.psc.ScenarioDocument;
import pl.psnc.vlab.ssa.gui.main.ResourceInfoOutlinePane;
import pl.psnc.vlab.ssa.management.SystemConfigurationFactory;
import pl.psnc.vlab.ssa.util.Keys;
import pl.psnc.vlab.util.i18n.ResourceBundleManager;
import pl.psnc.vlab.util.image.ImageFactory;
import pl.psnc.vlab.util.swing.gui.ColorKeys;
import pl.psnc.vlab.util.swing.gui.GenericGradientPane;
import pl.psnc.vlab.util.swing.gui.GuiTools;
import pl.psnc.vlab.util.swing.gui.Message;
import pl.psnc.vlab.xml.WizardScenarioFactory;

/**
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email  osa@man.poznan.pl
 */
public class JScenarioWizard extends JDialog {
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    // JForm constants - refer to JScenarioWizard.jfd
    private static final RowSpec CAT_ROW  = new RowSpec(RowSpec.CENTER, Sizes.DEFAULT, FormSpec.DEFAULT_GROW);
    private static final RowSpec CAT_SEP[] = new RowSpec[] {FormFactory.UNRELATED_GAP_ROWSPEC, FormFactory.DEFAULT_ROWSPEC, FormFactory.UNRELATED_GAP_ROWSPEC };
    private static final int COL_INDEX = 3;
    
    
    /** The form resource bundle */
    private ResourceBundleManager bundle;
    
    /** Map with scenario panes */
    private Map scenarioPaneMap;
    
    
    public JScenarioWizard(Frame owner) throws VlabException {
        super(owner);
        initComponents();
        Locale locale = SystemConfigurationFactory.getInstance().getCurrentLocale();
        bundle = new ResourceBundleManager("pl.psnc.vlab.ssa.gui.scenario.ScenarioWizard", locale);
        scenarioPaneMap = new HashMap(5);
        //init categories and scenarios
        initCategoryPane();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        pack();
        Dimension dialogSize = getSize();
        setBounds((screenSize.width-dialogSize.width)/2, (screenSize.height-dialogSize.height)/2, dialogSize.width, dialogSize.height);
        
    }
    
    
    /** CategoryChangeListener */
    class CategoryChangeListener implements PropertyChangeListener {
        /** Stores the category */
        JComponent asCategory;
        CategoryChangeListener(JComponent asCategory){
            super();
            this.asCategory = asCategory;
        }
        
        /**
         * Property change listener - handles mouse clicks on the categories
         * @param evt
         */
        public void propertyChange(PropertyChangeEvent evt){
            log.debug("<propertyChange name="+asCategory.getName()+ ">");
            asCategory.setEnabled(selectedComp == asCategory);
            //update scneario pane
            try{
                CategoryDocument.Category category = WizardScenarioFactory.getInstance().getCategory(selectedComp.getName());
                initScenarioPane(category);
            }catch (Exception err){
                log.error("Error occured during scenario building process."+Keys.LINE_SEPARATOR
                        +"Details: "+err.getMessage());
                Message.showInfoMessage(getParent(), "Error occured during scenario building process."+Keys.LINE_SEPARATOR
                        +"Details: "+err.getMessage(), Message.MESSAGE_TYPE_ERROR);
            }
        }
    }
    
    
    
    private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY//GEN-BEGIN:initComponents
		// Generated using JFormDesigner Evaluation license - Vlab Vlab
		ResourceBundle bundle = ResourceBundle.getBundle("pl.psnc.vlab.ssa.gui.scenario.ScenarioWizard");
		DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
		jHeaderPane = new GenericGradientPane(ColorKeys.GRADIENT_PANE_HEADER[0], ColorKeys.GRADIENT_PANE_HEADER[1]);
		jHTitleLbl = compFactory.createTitle(bundle.getString("scen.wizard.jHTitleLbl.textWithMnemonic"));
		jHTitleIcon = new JLabel();
		jHTitleDescLbl = compFactory.createLabel(bundle.getString("scen.wizard.jHTitleDescLbl.textWithMnemonic"));
		jContentPane = new JPanel();
		panel1 = new JScrollPane();
		splitPane1 = new JSplitPane();
		jCategoryIntFrm = new SimpleInternalFrame();
		jCatContentPane = new GenericGradientPane(ColorKeys.GRADIENT_LIGHT_GRAY_AND_WHITE[1], ColorKeys.GRADIENT_LIGHT_GRAY_AND_WHITE[0]);
		jScenarioListIntFrm = new SimpleInternalFrame();
		jScenScrollPane = new JScrollPane();
		jButtonPane = new JPanel();
		jOkBtn = new JButton();
		jCancelBtn = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setModal(true);
		Container contentPane = getContentPane();
		contentPane.setLayout(new FormLayout(
			ColumnSpec.decodeSpecs("default:grow"),
			new RowSpec[] {
				new RowSpec(RowSpec.FILL, Sizes.dluY(72), FormSpec.NO_GROW),
				FormFactory.PARAGRAPH_GAP_ROWSPEC,
				new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
			}));

		//======== jHeaderPane ========
		{
			jHeaderPane.setBorder(new MatteBorder(0, 0, 1, 0, Color.black));
			jHeaderPane.setMinimumSize(new Dimension(50, 90));

			// JFormDesigner evaluation mark
			jHeaderPane.setBorder(new javax.swing.border.CompoundBorder(
				new javax.swing.border.TitledBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0),
					"JFormDesigner Evaluation", javax.swing.border.TitledBorder.CENTER,
					javax.swing.border.TitledBorder.BOTTOM, new java.awt.Font("Dialog", java.awt.Font.BOLD, 12),
					java.awt.Color.red), jHeaderPane.getBorder())); jHeaderPane.addPropertyChangeListener(new java.beans.PropertyChangeListener(){public void propertyChange(java.beans.PropertyChangeEvent e){if("border".equals(e.getPropertyName()))throw new RuntimeException();}});

			jHeaderPane.setLayout(new FormLayout(
				new ColumnSpec[] {
					FormFactory.UNRELATED_GAP_COLSPEC,
					FormFactory.RELATED_GAP_COLSPEC,
					new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.DEFAULT_COLSPEC,
					FormFactory.DEFAULT_COLSPEC,
					FormFactory.LABEL_COMPONENT_GAP_COLSPEC
				},
				new RowSpec[] {
					FormFactory.PARAGRAPH_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.RELATED_GAP_ROWSPEC,
					new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.NO_GROW),
					FormFactory.LINE_GAP_ROWSPEC,
					new RowSpec(RowSpec.CENTER, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.PARAGRAPH_GAP_ROWSPEC
				}));
			((FormLayout)jHeaderPane.getLayout()).setColumnGroups(new int[][] {{1, 6}});
			jHeaderPane.add(jHTitleLbl, cc.xywh(2, 2, 2, 1));

			//---- jHTitleIcon ----
			jHTitleIcon.setIcon(new ImageIcon(getClass().getResource("/images/dialog/wizard.gif")));
			jHeaderPane.add(jHTitleIcon, cc.xywh(5, 2, 1, 5));
			jHeaderPane.add(jHTitleDescLbl, cc.xy(3, 4));
		}
		contentPane.add(jHeaderPane, cc.xy(1, 1));

		//======== jContentPane ========
		{
			jContentPane.setPreferredSize(new Dimension(700, 400));
			jContentPane.setMinimumSize(new Dimension(264, 150));
			jContentPane.setLayout(new FormLayout(
				new ColumnSpec[] {
					FormFactory.RELATED_GAP_COLSPEC,
					new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.RELATED_GAP_COLSPEC
				},
				new RowSpec[] {
					new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.PARAGRAPH_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.PARAGRAPH_GAP_ROWSPEC
				}));
			((FormLayout)jContentPane.getLayout()).setColumnGroups(new int[][] {{1, 3}});

			//======== panel1 ========
			{
				panel1.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));

				//======== splitPane1 ========
				{
					splitPane1.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
					splitPane1.setResizeWeight(0.3);

					//======== jCategoryIntFrm ========
					{
						jCategoryIntFrm.setTitle(bundle.getString("scen.wizard.jCategoryIntFrm.title"));
						jCategoryIntFrm.setPreferredSize(new Dimension(200, 143));
						jCategoryIntFrm.setMinimumSize(new Dimension(50, 48));
						Container jCategoryIntFrmContentPane = jCategoryIntFrm.getContentPane();
						jCategoryIntFrmContentPane.setLayout(new FormLayout(
							"default:grow",
							"fill:default:grow"));

						//======== jCatContentPane ========
						{
							jCatContentPane.setLayout(new FormLayout(
								new ColumnSpec[] {
									FormFactory.RELATED_GAP_COLSPEC,
									FormFactory.UNRELATED_GAP_COLSPEC,
									new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
									FormFactory.DEFAULT_COLSPEC,
									FormFactory.UNRELATED_GAP_COLSPEC
								},
								new RowSpec[] {
									FormFactory.UNRELATED_GAP_ROWSPEC,
									FormFactory.DEFAULT_ROWSPEC,
									new RowSpec(RowSpec.CENTER, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
									FormFactory.UNRELATED_GAP_ROWSPEC,
									FormFactory.DEFAULT_ROWSPEC,
									FormFactory.UNRELATED_GAP_ROWSPEC,
									new RowSpec(RowSpec.CENTER, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
									new RowSpec("fill:min(default;20dlu):grow(0.1)")
								}));
							((FormLayout)jCatContentPane.getLayout()).setColumnGroups(new int[][] {{1, 5}, {2, 4}});
						}
						jCategoryIntFrmContentPane.add(jCatContentPane, cc.xy(1, 1));
					}
					splitPane1.setLeftComponent(jCategoryIntFrm);

					//======== jScenarioListIntFrm ========
					{
						jScenarioListIntFrm.setTitle(bundle.getString("scen.wizard.jScenarioListIntFrm.title"));
						jScenarioListIntFrm.setMinimumSize(new Dimension(50, 46));
						jScenarioListIntFrm.setPreferredSize(new Dimension(400, 126));
						Container jScenarioListIntFrmContentPane = jScenarioListIntFrm.getContentPane();
						jScenarioListIntFrmContentPane.setLayout(new FormLayout(
							"default:grow",
							"fill:default:grow"));

						//======== jScenScrollPane ========
						{
							jScenScrollPane.setBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
							jScenScrollPane.setRequestFocusEnabled(false);
							jScenScrollPane.setPreferredSize(new Dimension(186, 300));
							jScenScrollPane.setViewportBorder(Borders.createEmptyBorder("0dlu, 0dlu, 0dlu, 0dlu"));
						}
						jScenarioListIntFrmContentPane.add(jScenScrollPane, cc.xy(1, 1));
					}
					splitPane1.setRightComponent(jScenarioListIntFrm);
				}
				panel1.setViewportView(splitPane1);
			}
			jContentPane.add(panel1, cc.xy(2, 1));

			//======== jButtonPane ========
			{
				jButtonPane.setMaximumSize(new Dimension(2147483647, 50));
				jButtonPane.setLayout(new FormLayout(
					new ColumnSpec[] {
						new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
						FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
						new ColumnSpec("max(pref;50dlu)"),
						FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
						new ColumnSpec("max(pref;50dlu)")
					},
					RowSpec.decodeSpecs("max(default;25dlu)")));
				((FormLayout)jButtonPane.getLayout()).setColumnGroups(new int[][] {{3, 5}});

				//---- jOkBtn ----
				jOkBtn.setText(bundle.getString("scen.wizard.jOkBtn.text"));
				jOkBtn.setIcon(new ImageIcon(getClass().getResource("/images/buttons/ok.gif")));
				jOkBtn.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						jOkBtnActionPerformed(e);
					}
				});
				jButtonPane.add(jOkBtn, cc.xy(3, 1));

				//---- jCancelBtn ----
				jCancelBtn.setText(bundle.getString("scen.wizard.jCancelBtn.text"));
				jCancelBtn.setIcon(new ImageIcon(getClass().getResource("/images/buttons/delete_obj.gif")));
				jCancelBtn.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						jCancelBtnActionPerformed(e);
					}
				});
				jButtonPane.add(jCancelBtn, cc.xy(5, 1));
			}
			jContentPane.add(jButtonPane, cc.xy(2, 3));
		}
		contentPane.add(jContentPane, cc.xy(1, 3));
		// JFormDesigner - End of component initialization//GEN-END:initComponents
    }
    
	// JFormDesigner - Variables declaration - DO NOT MODIFY//GEN-BEGIN:variables
	// Generated using JFormDesigner Evaluation license - Vlab Vlab
	private GenericGradientPane jHeaderPane;
	private JLabel jHTitleLbl;
	private JLabel jHTitleIcon;
	private JLabel jHTitleDescLbl;
	private JPanel jContentPane;
	private JScrollPane panel1;
	private JSplitPane splitPane1;
	private SimpleInternalFrame jCategoryIntFrm;
	private GenericGradientPane jCatContentPane;
	private SimpleInternalFrame jScenarioListIntFrm;
	private JScrollPane jScenScrollPane;
	private JPanel jButtonPane;
	private JButton jOkBtn;
	private JButton jCancelBtn;
	// JFormDesigner - End of variables declaration//GEN-END:variables
    
    
    //--------------------------------------------------------------------------
    //----- Private, internal helper methods
    
    /** Initialize wizard categories */
    private void initCategoryPane() throws VlabException{
        CellConstraints cc = new CellConstraints();
        DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
        JComponent catSeparator = compFactory.createSeparator("");
        catSeparator.setForeground(Color.orange);
        
        WizardScenarioFactory wizardFactory = WizardScenarioFactory.getInstance();
        CategoryDocument.Category catList[] = wizardFactory.getCategoryList();
        
        int size = catList != null ? catList.length : 0;
        //create layout
        FormLayout layout = new FormLayout(
                new ColumnSpec[] {
            FormFactory.RELATED_GAP_COLSPEC,
            FormFactory.UNRELATED_GAP_COLSPEC,
            new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
            FormFactory.DEFAULT_COLSPEC,
            FormFactory.UNRELATED_GAP_COLSPEC
        },
                new RowSpec[]{
            FormFactory.UNRELATED_GAP_ROWSPEC,
            FormFactory.DEFAULT_ROWSPEC} );
        
        jCatContentPane.setLayout(layout);
        ((FormLayout)jCatContentPane.getLayout()).setColumnGroups(new int[][] {{1, 5}, {2, 4}});
        JComponent jCatTitleSep = compFactory.createSeparator(bundle.getValue("scen.wizard.jCatTitleSep.text"));
        jCatContentPane.add(jCatTitleSep , cc.xywh(2, 2, 3, 1));
        
        //add categories
        for(int i=0; i<size; i++){
            //add new row
            log.debug("Adding new category row index="+i);
            layout.appendRow(CAT_ROW);
            int rowCount = layout.getRowCount();
            log.debug("Row numbers="+rowCount);
            
            appendCategory(catList[i], cc, rowCount);
            //add cat separator
            if(i<size-1){
                layout.appendRow(CAT_SEP[0]);
                layout.appendRow(CAT_SEP[1]);
                layout.appendRow(CAT_SEP[0]);
                jCatContentPane.add(catSeparator, cc.xywh(2, rowCount + 2 , 3, 1));
            }
        }
        //add last row
        layout.appendRow(new RowSpec("fill:min(default;20dlu):grow(0.1)"));
        propertyChangeSupport.firePropertyChange("selectedComp", null, selectedComp);
    }
    
    
    /**
     * Initialize wizard scenarios within the given category
     * @param category
     * @throws pl.psnc.vlab.exception.VlabException
     */
    private void initScenarioPane(CategoryDocument.Category category) throws VlabException{
        String catName = category != null ? category.getName() : "";
        log.debug("<initScenarioPane category="+catName+">");
        //cache lookup
        JComponent pane = (JComponent) this.scenarioPaneMap.get(catName);
        if(pane == null){
            log.debug("Pane for category="+catName+" not found.");
            pane = buildScenarioPane( (category != null ? category.getScenarioArray() : null) );            
            this.scenarioPaneMap.put(catName, pane);
        }
        
        jScenScrollPane.setViewportView(pane);
        log.debug("</initScenarioPane>");
        return;
    }
    
    
    
    /**
     * Builds pane filled with the scnenarios from the given category
     * @return pane with scenarios
     * @param scenList scanario list
     * @throws pl.psnc.vlab.exception.VlabException
     */
    private JComponent buildScenarioPane(ScenarioDocument.Scenario scenList[]) throws VlabException{
        log.debug("<buildScenarioPane>");
        CellConstraints cc = new CellConstraints();
        DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
        
        JComponent resultPane = null;
        int size = scenList != null ? scenList.length : 0;
        if(size == 0){
            //add no items pane; reuse ResourceInfoOutlinePane pane
            resultPane = new ResourceInfoOutlinePane();
            log.debug("</buildScenarioPane size=0>");
            return resultPane;
        }
        
        resultPane = new GenericGradientPane(ColorKeys.GRADIENT_LIGHT_GRAY_AND_WHITE[0], ColorKeys.GRADIENT_LIGHT_GRAY_AND_WHITE[1]);
        //resultPane.setMaximumSize(new Dimension(32767, 32000));
        //resultPane.setMinimumSize(new Dimension(200, 300));
        //resultPane.setPreferredSize(new Dimension(250, 500));
        //create layout
        FormLayout layout = new FormLayout(
                new ColumnSpec[] {
            FormFactory.RELATED_GAP_COLSPEC,
            FormFactory.UNRELATED_GAP_COLSPEC,
            new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
            FormFactory.DEFAULT_COLSPEC,
            FormFactory.UNRELATED_GAP_COLSPEC
        },
                new RowSpec[]{
            FormFactory.UNRELATED_GAP_ROWSPEC,
            FormFactory.DEFAULT_ROWSPEC} );
        
        resultPane.setLayout(layout);
        ((FormLayout) resultPane.getLayout()).setColumnGroups(new int[][] {{1, 5}, {2, 4}});
        JComponent jTitleSep = compFactory.createSeparator(bundle.getValue("scen.wizard.jScenSepTitle.text"));
        resultPane.add(jTitleSep , cc.xywh(2, 2, 3, 1));
        JComponent catSeparator = null;
        
        int height = 70;
        //add scenarios
        for(int i=0; i<size; i++){
            //add new row
            log.debug("Adding new scenario row index="+i);
            layout.appendRow(CAT_ROW);
            int rowCount = layout.getRowCount();
            log.debug("Row numbers="+rowCount);
            
            appendScenario(scenList[i],resultPane, cc, rowCount);            
            //add cat separator
            if(i<size-1){
                layout.appendRow(CAT_SEP[0]);
                layout.appendRow(CAT_SEP[1]);
                layout.appendRow(CAT_SEP[0]);
                catSeparator = compFactory.createSeparator("");
                catSeparator.setForeground(Color.orange);
                resultPane.add(catSeparator, cc.xywh(2, rowCount + 2 , 3, 1));
                height += 220;
            }
        }
        //add last row
        layout.appendRow(new RowSpec("fill:min(default;20dlu):grow(0.1)"));        
        resultPane.setPreferredSize(new Dimension(250, height));
        log.debug("Height="+height);
        log.debug("</buildScenarioPane>");
        return resultPane;
    }
    
    
    
    
    
    /**
     * Append new category represented as JLabel
     *
     * @return new category
     * @param cc cell constraints object
     *
     * @param rowIndex current row index
     * @param category category to be added
     */
    private JComponent appendCategory(CategoryDocument.Category category, CellConstraints cc, int rowIndex ) throws VlabException{
        try{
            String name = category.getName();
            log.debug("<appendCategory name="+name);
            JLabel jLabel = new JLabel(bundle.getValue(name));
            jLabel.setName(name);   //set name
            
            //set icon
            jLabel.setIcon(ImageFactory.getImageBean(category.getIcon()).getImage() );
            jLabel.setIconTextGap(8);
            //set tooltip
            jLabel.setToolTipText(bundle.getValue(category.getDescription()));
            jCatContentPane.add(jLabel, cc.xy(COL_INDEX, rowIndex));
            //add property change listener
            if(this.selectedComp== null){
                this.setSelectedComp(jLabel);
            }
            addPropertyChangeListener(new CategoryChangeListener(jLabel));
            
            
            //add mouse events handlers
            jLabel.addMouseListener(new MouseAdapter() {
                
                public void mouseEntered(MouseEvent e) {
                    jMouseEntered(e);
                }
                public void mouseExited(MouseEvent e) {
                    jMouseExited(e);
                }
                public void mousePressed(MouseEvent e) {
                    jMousePressed(e);
                }
            });
            log.debug("</appendCategory>");
            return jLabel;
        }catch(Exception err){
            log.debug("</appendCategory:err>");
            throw new VlabException("Error initializnig category. Index="+rowIndex, err);
        }
    }
    
    
    
    /**
     * Append new scenario represented as JLabel
     *
     * @return new scenario
     * @param scenario
     * @param pane pane to which scenario components will be added
     * @param cc cell constraints object
     * @param rowIndex current row index
     * @throws pl.psnc.vlab.exception.VlabException
     */
    private JComponent appendScenario(ScenarioDocument.Scenario scenario, JComponent pane, CellConstraints cc, int rowIndex ) throws VlabException{
        try{
            String name = scenario.getName();
            log.debug("<appendScenario name="+name);
            JComponent jScenPane = new JScenarioWPane(this, scenario, bundle);
            pane.add(jScenPane, cc.xy(COL_INDEX, rowIndex));
            return jScenPane;
        }catch(Exception err){
            log.debug("</appendScenario:err>");
            throw new VlabException("Error initializnig scenario. Index="+rowIndex, err);
        }
    }
    
    
    /**
     * Holds value of property selectedComp.
     */
    private JComponent selectedComp;
    
    
    /**
     * Getter for property selectedComp.
     * @return Value of property selectedComp.
     */
    public JComponent getSelectedComp() {
        return this.selectedComp;
    }
    
    /**
     * Setter for property selectedComp.
     * @param selectedComp New value of property selectedComp.
     */
    public void setSelectedComp(JComponent selectedComp) {
        JComponent oldSelectedComp = this.selectedComp;
        this.selectedComp = selectedComp;
        propertyChangeSupport.firePropertyChange("selectedComp", oldSelectedComp, selectedComp);
    }
    
    
    
    //--------------------------------------------------------------------------
    // Event handlers
    
    /**
     * Utility field used by bound properties.
     */
    private java.beans.PropertyChangeSupport propertyChangeSupport =  new java.beans.PropertyChangeSupport(this);
    
    /**
     * Adds a PropertyChangeListener to the listener list.
     * @param l The listener to add.
     */
    public void addPropertyChangeListener(java.beans.PropertyChangeListener l) {
        propertyChangeSupport.addPropertyChangeListener(l);
    }
    
    /**
     * Removes a PropertyChangeListener from the listener list.
     * @param l The listener to remove.
     */
    public void removePropertyChangeListener(java.beans.PropertyChangeListener l) {
        propertyChangeSupport.removePropertyChangeListener(l);
    }
    
    
    /**
     * Handles the mouseEntered event
     * @param e
     */
    private void jMouseEntered(MouseEvent e){
        JComponent comp = (JComponent) e.getSource();
        GuiTools.makeHyperLink(comp);
        comp.setEnabled(true);
    }
    
    /**
     * Handles the mouseExited event
     * @param e
     */
    private void jMouseExited(MouseEvent e){
        JComponent comp = (JComponent) e.getSource();
        GuiTools.removeHyperLink(comp);
        comp.setEnabled(comp == getSelectedComp());
    }
    
    /**
     * Handles the mousePressed event
     * @param e
     */
    private void jMousePressed(MouseEvent e)  {
        setSelectedComp((JComponent) e.getSource());
    }
    
    
    
    /**
     * Handles the mouseEntered event
     * @param e
     */
    private void jScenMouseEntered(MouseEvent e){
        JComponent comp = (JComponent) e.getSource();
        GuiTools.makeHyperLink(comp);
    }
    
    /**
     * Handles the mouseExited event
     * @param e
     */
    private void jScenMouseExited(MouseEvent e){
        JComponent comp = (JComponent) e.getSource();
        GuiTools.removeHyperLink(comp);
    }
    
    
    
    /**
     * Handles OK button event 
     * @param e 
     */
    private void jOkBtnActionPerformed(ActionEvent e) {
        // TODO add your code here
    }
    
    
    /**
     * Handles Cancel button event 
     * @param e 
     */
    private void jCancelBtnActionPerformed(ActionEvent e) {
        setVisible(false);
        dispose();
    }
}
