/*
 * Created by JFormDesigner on Wed Feb 01 16:04:33 CET 2006
 */

package pl.psnc.vlab.ssa.gui.scenario;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.Document;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.rds.ScenarioDocument;
import pl.psnc.vlab.ssa.gui.MainFrame;
import pl.psnc.vlab.ssa.gui.MainFrameBase;
import pl.psnc.vlab.ssa.gui.resource.document.NormalizedDocument;
import pl.psnc.vlab.ssa.util.AppMessage;
import pl.psnc.vlab.ssa.util.i18n.MessageBundleFactory;
import pl.psnc.vlab.ssa.util.i18n.SSABundleFactory;
import pl.psnc.vlab.util.swing.gui.*;
import pl.psnc.vlab.xml.ScenarioBuilder;

/**
 * @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email  osa@man.poznan.pl
 */
public class ScenarioPropertiesDialog extends JDialog {
    
    /** Instance of logger */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Stores the user choice: OK, CANCEL*/
    private int result;
    
    /** Stores an instance of the inner class */
    private ScenarioPropertiesDialog.ChangeObserver changeObserver;
    
    /** Instance of the scenario description */
    private ScenarioDocument.Scenario scenario = null;
    
    public ScenarioPropertiesDialog(java.awt.Frame parent, boolean modal, ScenarioDocument.Scenario scenario) {        
        super(parent, modal);
        try{
            initComponents();
            this.scenario = scenario;
            this.changeObserver = this.new ChangeObserver();
            String maxCharExceeded     = MessageBundleFactory.getValue("component.max.length.exceeded");
            String invalidCharInserted = MessageBundleFactory.getValue("component.ivalid.char.inserted");
            
            jScenNameVal.setDocument(new NormalizedDocument(50, maxCharExceeded, invalidCharInserted));
            jScenNameVal.getDocument().addDocumentListener(new MyDocumentListener(jScenNameVal));
            jScenDescVal.setDocument(new NormalizedDocument(150, maxCharExceeded, invalidCharInserted));
            jScenDescVal.getDocument().addDocumentListener(new MyDocumentListener(jScenDescVal));
            MainFrameBase base = MainFrame.getInstance().getBasePane();
            addNewObserver(base.getJScenDetailsPane());
            jScenCreationDateVal.setBackground(Color.white);
            jScenModificationDateVal.setBackground(Color.white);
            jScenModifiedByVal.setBackground(Color.white);
            
            setFields();
            pack();
            
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            Dimension dialogSize = getSize();
            setBounds((screenSize.width-dialogSize.width)/2, (screenSize.height-dialogSize.height)/2, dialogSize.width, dialogSize.height);
        }catch(Exception err){
            //tbd
            err.printStackTrace();
        }
    }
    
    
    
    class MyDocumentListener implements DocumentListener {
        /** Stores instance of source component */
        private JComponent component;
        
        public MyDocumentListener(JComponent component){
            this.component = component;            
        }
        
        public void insertUpdate(DocumentEvent e) {
            //dummy - don need that
        }
        
        public void removeUpdate(DocumentEvent e) {
            //dummy - don need that            
        }
        
        public void changedUpdate(DocumentEvent e) {
            NormalizedDocument.UpdateTooltipDocEvent event = (NormalizedDocument.UpdateTooltipDocEvent) e;          
            component.setToolTipText(event.getToolTip());
            component.dispatchEvent( new KeyEvent(component, KeyEvent.KEY_PRESSED, 0, KeyEvent.CTRL_MASK, KeyEvent.VK_F1) );
        }
        
    }
    
    
    /**
     * Adds an observer to the set of observers for this object, provided
     * that it is not the same as some observer already in the set.
     * The order in which notifications will be delivered to multiple
     * observers is not specified. See the class comment.
     *
     * @param   o   an observer to be added.
     * @throws NullPointerException   if the parameter o is null.
     */
    public void addNewObserver(Observer o) {
        log.debug("Observer added");
        this.changeObserver.addObserver(o);
    }
    
    class ChangeObserver extends Observable {
        /**
         * Marks this <tt>Observable</tt> object as having been changed; the
         * <tt>hasChanged</tt> method will now return <tt>true</tt>.
         */
        public void setChanged() {
            
            super.setChanged();
        }
        
        /**
         * If this object has changed, as indicated by the
         * <code>hasChanged</code> method, then notify all of its observers
         * and then call the <code>clearChanged</code> method to indicate
         * that this object has no longer changed.
         * <p>
         * Each observer has its <code>update</code> method called with two
         * arguments: this observable object and the <code>arg</code> argument.
         *
         * @param   arg   any object.
         * @see     java.util.Observable#clearChanged()
         * @see     java.util.Observable#hasChanged()
         * @see     java.util.Observer#update(java.util.Observable, java.lang.Object)
         */
        public void notifyObservers(Object arg) {
            super.notifyObservers(arg);
            log.debug("notifyObservers(arg)");
        }
        
        /**
         * If this object has changed, as indicated by the
         * <code>hasChanged</code> method, then notify all of its observers
         * and then call the <code>clearChanged</code> method to
         * indicate that this object has no longer changed.
         * <p>
         * Each observer has its <code>update</code> method called with two
         * arguments: this observable object and <code>null</code>. In other
         * words, this method is equivalent to:
         * <blockquote><tt>
         * notifyObservers(null)</tt></blockquote>
         *
         * @see     java.util.Observable#clearChanged()
         * @see     java.util.Observable#hasChanged()
         * @see     java.util.Observer#update(java.util.Observable, java.lang.Object)
         */
        public void notifyObservers() {
            super.notifyObservers();
            log.debug("notifyObservers");
        }
        
        
    }
    
    private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY//GEN-BEGIN:initComponents
		// Generated using JFormDesigner Evaluation license - Vlab Vlab
		ResourceBundle bundle = ResourceBundle.getBundle("pl.psnc.vlab.ssa.gui.scenario.ScenarioProperties");
		DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
		jHeaderPane = new GenericGradientPane(ColorKeys.GRADIENT_PANE_HEADER[0], ColorKeys.GRADIENT_PANE_HEADER[1]);
		jHTitleLbl = compFactory.createTitle(bundle.getString("scen.prop.form.jHTitleLbl.textWithMnemonic"));
		jHTitleIcon = new JLabel();
		jHTitleDescLbl = compFactory.createLabel(bundle.getString("scen.prop.form.jHTitleDescLbl.textWithMnemonic"));
		jContentPane = new JPanel();
		panel1 = new JPanel();
		goodiesFormsSeparator1 = compFactory.createSeparator(bundle.getString("scen.prop.form.goodiesFormsSeparator1.text"));
		jScenName = compFactory.createTitle(bundle.getString("scen.prop.form.jScenName.textWithMnemonic"));
		jScenNameVal = new JTextField();
		jScenDesc = compFactory.createTitle(bundle.getString("scen.prop.form.jScenDesc.textWithMnemonic"));
		scrollPane1 = new JScrollPane();
		jScenDescVal = new JTextArea();
		jDatesTitle = compFactory.createSeparator(bundle.getString("scen.prop.form.jDatesTitle.text"));
		jCreationDate = compFactory.createTitle(bundle.getString("scen.prop.form.jCreationDate.textWithMnemonic"));
		jScenCreationDateVal = new JTextField();
		jScenModDate = compFactory.createTitle(bundle.getString("scen.prop.form.jScenModDate.textWithMnemonic"));
		jScenModificationDateVal = new JTextField();
		jScenModifiedBy = compFactory.createTitle(bundle.getString("scen.prop.form.jScenModifiedBy.textWithMnemonic"));
		jScenModifiedByVal = new JTextField();
		jButtonPane = new JPanel();
		jOkBtn = new JButton();
		jCancelBtn = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setModal(true);
		Container contentPane = getContentPane();
		contentPane.setLayout(new FormLayout(
			ColumnSpec.decodeSpecs("default:grow"),
			new RowSpec[] {
				new RowSpec(RowSpec.FILL, Sizes.dluY(72), FormSpec.NO_GROW),
				FormFactory.LINE_GAP_ROWSPEC,
				new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
				FormFactory.LINE_GAP_ROWSPEC
			}));

		//======== jHeaderPane ========
		{
			jHeaderPane.setBorder(LineBorder.createBlackLineBorder());
			jHeaderPane.setPreferredSize(new Dimension(400, 100));


			jHeaderPane.setLayout(new FormLayout(
				new ColumnSpec[] {
					FormFactory.UNRELATED_GAP_COLSPEC,
					FormFactory.RELATED_GAP_COLSPEC,
					new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.DEFAULT_COLSPEC,
					FormFactory.DEFAULT_COLSPEC,
					FormFactory.LABEL_COMPONENT_GAP_COLSPEC
				},
				new RowSpec[] {
					FormFactory.PARAGRAPH_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC,
					FormFactory.RELATED_GAP_ROWSPEC,
					new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.NO_GROW),
					FormFactory.LINE_GAP_ROWSPEC,
					new RowSpec(RowSpec.CENTER, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.PARAGRAPH_GAP_ROWSPEC
				}));
			((FormLayout)jHeaderPane.getLayout()).setColumnGroups(new int[][] {{1, 6}});
			jHeaderPane.add(jHTitleLbl, cc.xywh(2, 2, 2, 1));

			//---- jHTitleIcon ----
			jHTitleIcon.setIcon(new ImageIcon(getClass().getResource("/images/vlab/scenSample.gif")));
			jHeaderPane.add(jHTitleIcon, cc.xywh(5, 2, 1, 5));
			jHeaderPane.add(jHTitleDescLbl, cc.xy(3, 4));
		}
		contentPane.add(jHeaderPane, cc.xy(1, 1));

		//======== jContentPane ========
		{
			jContentPane.setPreferredSize(new Dimension(400, 300));
			jContentPane.setMinimumSize(new Dimension(264, 150));
			jContentPane.setLayout(new FormLayout(
				new ColumnSpec[] {
					FormFactory.RELATED_GAP_COLSPEC,
					new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.RELATED_GAP_COLSPEC
				},
				new RowSpec[] {
					new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
					FormFactory.PARAGRAPH_GAP_ROWSPEC,
					FormFactory.DEFAULT_ROWSPEC
				}));
			((FormLayout)jContentPane.getLayout()).setColumnGroups(new int[][] {{1, 3}});

			//======== panel1 ========
			{
				panel1.setLayout(new FormLayout(
					new ColumnSpec[] {
						FormFactory.UNRELATED_GAP_COLSPEC,
						FormFactory.RELATED_GAP_COLSPEC,
						new ColumnSpec("right:max(pref;30dlu):grow(0.1)"),
						FormFactory.UNRELATED_GAP_COLSPEC,
						new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
						FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
						FormFactory.UNRELATED_GAP_COLSPEC
					},
					new RowSpec[] {
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						new RowSpec(RowSpec.FILL, Sizes.dluY(50), FormSpec.NO_GROW),
						new RowSpec("fill:min(default;20dlu):grow(0.1)"),
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.RELATED_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						new RowSpec("fill:min(default;20dlu):grow")
					}));
				((FormLayout)panel1.getLayout()).setColumnGroups(new int[][] {{1, 7}});
				panel1.add(goodiesFormsSeparator1, cc.xywh(2, 2, 5, 1));
				panel1.add(jScenName, cc.xy(3, 4));
				panel1.add(jScenNameVal, cc.xy(5, 4));
				panel1.add(jScenDesc, cc.xy(3, 6));

				//======== scrollPane1 ========
				{

					//---- jScenDescVal ----
					jScenDescVal.setColumns(10);
					jScenDescVal.setRows(4);
					jScenDescVal.setTabSize(4);
					jScenDescVal.setWrapStyleWord(true);
					jScenDescVal.setLineWrap(true);
					scrollPane1.setViewportView(jScenDescVal);
				}
				panel1.add(scrollPane1, cc.xy(5, 6));
				panel1.add(jDatesTitle, cc.xywh(2, 8, 5, 1));
				panel1.add(jCreationDate, cc.xy(3, 10));

				//---- jScenCreationDateVal ----
				jScenCreationDateVal.setEditable(false);
				jScenCreationDateVal.setHorizontalAlignment(SwingConstants.RIGHT);
				panel1.add(jScenCreationDateVal, cc.xy(5, 10));
				panel1.add(jScenModDate, cc.xy(3, 12));

				//---- jScenModificationDateVal ----
				jScenModificationDateVal.setEditable(false);
				jScenModificationDateVal.setHorizontalAlignment(SwingConstants.RIGHT);
				panel1.add(jScenModificationDateVal, cc.xy(5, 12));
				panel1.add(jScenModifiedBy, cc.xy(3, 14));

				//---- jScenModifiedByVal ----
				jScenModifiedByVal.setEditable(false);
				jScenModifiedByVal.setHorizontalAlignment(SwingConstants.RIGHT);
				panel1.add(jScenModifiedByVal, cc.xy(5, 14));
			}
			jContentPane.add(panel1, cc.xywh(2, 1, 1, 2));

			//======== jButtonPane ========
			{
				jButtonPane.setMaximumSize(new Dimension(2147483647, 50));
				jButtonPane.setLayout(new FormLayout(
					new ColumnSpec[] {
						new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
						FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
						FormFactory.BUTTON_COLSPEC,
						FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
						FormFactory.BUTTON_COLSPEC
					},
					RowSpec.decodeSpecs("max(default;25dlu)")));

				//---- jOkBtn ----
				jOkBtn.setText(bundle.getString("scen.prop.form.jOkBtn.text"));
				jOkBtn.setIcon(new ImageIcon(getClass().getResource("/images/buttons/ok.gif")));
				jOkBtn.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						jOkBtnActionPerformed(e);
					}
				});
				jButtonPane.add(jOkBtn, cc.xy(3, 1));

				//---- jCancelBtn ----
				jCancelBtn.setText(bundle.getString("scen.prop.form.jCancelBtn.text"));
				jCancelBtn.setIcon(new ImageIcon(getClass().getResource("/images/eclipse/menu/delete_edit.gif")));
				jCancelBtn.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						jCancelBtnActionPerformed(e);
					}
				});
				jButtonPane.add(jCancelBtn, cc.xy(5, 1));
			}
			jContentPane.add(jButtonPane, cc.xy(2, 3));
		}
		contentPane.add(jContentPane, cc.xy(1, 3));
		// JFormDesigner - End of component initialization//GEN-END:initComponents
    }
    
    private void jOkBtnActionPerformed(ActionEvent e) {
        try{
            this.result = JOptionPane.OK_OPTION;
            //fire observers update
            update();
            setVisible(false);
            dispose();
        } catch(Exception err){
            err.printStackTrace();
            Message.showInfoMessage(MainFrame.getInstance(), err.getMessage(), Message.MESSAGE_TYPE_ERROR);
        }
    }
    
    private void jCancelBtnActionPerformed(ActionEvent e) {
        this.result = JOptionPane.CANCEL_OPTION;
        setVisible(false);
        dispose();
    }
    
	// JFormDesigner - Variables declaration - DO NOT MODIFY//GEN-BEGIN:variables
	// Generated using JFormDesigner Evaluation license - Vlab Vlab
	private GenericGradientPane jHeaderPane;
	private JLabel jHTitleLbl;
	private JLabel jHTitleIcon;
	private JLabel jHTitleDescLbl;
	private JPanel jContentPane;
	private JPanel panel1;
	private JComponent goodiesFormsSeparator1;
	private JLabel jScenName;
	private JTextField jScenNameVal;
	private JLabel jScenDesc;
	private JScrollPane scrollPane1;
	private JTextArea jScenDescVal;
	private JComponent jDatesTitle;
	private JLabel jCreationDate;
	private JTextField jScenCreationDateVal;
	private JLabel jScenModDate;
	private JTextField jScenModificationDateVal;
	private JLabel jScenModifiedBy;
	private JTextField jScenModifiedByVal;
	private JPanel jButtonPane;
	private JButton jOkBtn;
	private JButton jCancelBtn;
	// JFormDesigner - End of variables declaration//GEN-END:variables
    
    
    /** Returns the user option : OK or CANCEL */
    public int getUserOption(){
        return this.result;
    }
    
    /** Set the frame fields to the values from the ScenarioDocument
     */
    private void setFields(){
        jScenNameVal.setText( scenario.getName());                            //set name
        jScenDescVal.setText( scenario.getDescription());                     //set description
        jScenCreationDateVal.setText( scenario.getCreationDate());            //set creation date
        jScenModificationDateVal.setText( scenario.getModificationDate());   //set modification date
        jScenModifiedByVal.setText( scenario.getModifiedBy());              //set modified by
    }
    
    /** Update the ScenarioDocument with the user provided values
     */
    private void update(){
        String name = jScenNameVal.getText();
        MainFrame.getInstance().updateTitle(name);
        scenario.setName(name);
        
        scenario.setDescription(jScenDescVal.getText());
        ScenarioBuilder.setScenarioDescription(scenario);
        this.changeObserver.setChanged();
        log.debug("About to update listeners. Count-"+this.changeObserver.countObservers());
        log.debug("changed="+this.changeObserver.hasChanged());
        changeObserver.notifyObservers(scenario);
    }
    
}
