/*
 * AppInitializer.java
 *
 * Created on 9 sierpie� 2004, 15:13
 */

package pl.psnc.vlab.ssa.management;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.ssa.exception.SSAException;
import pl.psnc.vlab.ssa.gui.about.SplashDialog;
import pl.psnc.vlab.ssa.util.AppMessage;
import pl.psnc.vlab.ssa.util.i18n.MessageBundleFactory;
import pl.psnc.vlab.util.swing.gui.Message;
import pl.psnc.vlab.util.swing.thread.LongTask;
import pl.psnc.vlab.util.swing.thread.SwingWorker;

/**
 *
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class AppInitializer implements LongTask{
    
    
    /** Logger instance */
    private Log log = LogFactory.getLog(this.getClass().getName());
    
    /** Represents an exception */
    private SSAException dynExc = null;
    
    /** Long tastk status */
    private boolean done = false;
    
    /** Instance of the Splash Dialog */
    private SplashDialog splashDialog = null;
    
    /** Creates a new instance of AppInitializer */
    public AppInitializer(SplashDialog splashDialog) {
        this.splashDialog = splashDialog;
        final SwingWorker worker = new SwingWorker() {
            public Object construct() {
                return new Init();
            }
            
            public void finished() {
                //MainFrame.getInstance().update(getTask());
            }
        };
        worker.start();
    }
    
    public boolean exceptionThrown() {
        return dynExc!=null;
    }
    
    public int getCurrent() {
        return 0;
    }
    
    public Exception getException() {
        return dynExc;
    }
    
    public Object getResult() {
        return null;
    }
    
    public int getTaskLength() {
        return 0;
    }
    
    public boolean isDone() {
        return done;
    }
    
    //tbd
    public int getProgress() {
        return 0;
    }
    
    
    
    /**
     * The actual long running task.  This runs in a SwingWorker thread.
     */
    class Init {
        Init() {
            try{
                log.debug("<Init>");
                //initialize java components
                splashDialog.setMessage(MessageBundleFactory.getValue("message.init.components"));
                Class.forName("pl.psnc.vlab.xml.ComponentFactory");
                //initialize resource types
                splashDialog.setMessage(MessageBundleFactory.getValue("message.init.resource.types"));
                Class.forName("pl.psnc.vlab.xml.TypeFactory");
                //initialize resource list
                splashDialog.setMessage(MessageBundleFactory.getValue("message.init.resource.list"));
                Class.forName("pl.psnc.vlab.xml.ResourceFactory");
                //initialize the connection list
                splashDialog.setMessage(MessageBundleFactory.getValue("message.init.resource.links"));
                Class.forName("pl.psnc.vlab.xml.LinksFactory");
                splashDialog.setMessage(MessageBundleFactory.getValue("message.init.start.app"));
                
                //get user proxy
                // tbd REMOVED
                /* try{
                    splashDialog.setMessage(MessageBundleFactory.getValue("message.init.get.proxy"));
                    byte proxy[] = ProxyFactory.getUserProxy();
                    //validate proxy
                    splashDialog.setMessage(MessageBundleFactory.getValue("message.proxy.validate.proxy"));
                    if(!ProxyFactory.isProxyValid(proxy)){
                        Message.showInfoMessage(null, AppMessage.MSG_WARN_INVALID_PROXY, Message.MESSAGE_TYPE_INF);
                    }
                }catch(Exception e){
                    e.printStackTrace();
                    Message.showInfoMessage(null, AppMessage.MSG_WARN_INVALID_PROXY, Message.MESSAGE_TYPE_INF);
                }
                */
                done = true;
                log.debug("</Init>");
            } catch(java.lang.Exception er) {
                er.printStackTrace();
                done = true;
                log.debug("</Init-Err>");
                dynExc = new SSAException(er.getMessage(), er);
            }
            
        }
    }// end of Init class
}