/*
 * SSAConfiguration.java
 *
 * Created on February 21, 2006, 3:34 PM
 *
 */

package pl.psnc.vlab.ssa.management;

import pl.psnc.vlab.conf.Configuration;
import pl.psnc.vlab.exception.VlabException;

/**
 * SSA configuration keys and methods
 * @author @author <a href="mailto:osa@man.poznan.pl">Dominik Stoklosa (~osa~)</a>
 * @email osa@man.poznan.pl
 */
public interface SSAConfiguration  extends Configuration {
    
    /** Specifies the location of the file with the predefined scenarios */
    static final String KEY_DEVICE_LOCATION = "deviceLocation";
    
    
    /**
     * Returns the location of the file containing the devices
     * 
     * @return predefined scenarios location
     * @throws pl.psnc.vlab.exception.VlabException 
     */
    public String getDeviceLocation() throws VlabException;
    
}
