/*
 * AppMessage.java
 *
 * Created on 25 marzec 2004, 11:12
 */

package pl.psnc.vlab.ssa.util;

import java.util.ResourceBundle;
import pl.psnc.vlab.ssa.util.i18n.MessageBundleFactory;

/**
 * The class contains all common application messages which are
 * shown to user.
 * @author  osa
 * @email osa@man.poznan.pl
 */
public class AppMessage {
    
    
    
    //-----------------------------------
    //---- File operations messages
    /** File already exists*/
    public static String MSG_FILE_EXISTS = new StringBuffer()
    .append(MessageBundleFactory.getValue("message.file.exists"))
    .append(Keys.LINE_SEPARATOR)
    .append(MessageBundleFactory.getValue("message.overwrite.file")).toString();
    
    /** File already exists - window title */
    public static String MSG_FILE_EXISTS_TITLE = "Save file";
    
    
    //-----------------------------------
    //---- Submitting scenario
    public static final String SCEN_NO_INITIAL_NODE = MessageBundleFactory.getValue("message.submit.no.initial.node");
    public static final String SCEN_NO_NAME_DEFINED = MessageBundleFactory.getValue("message.submit.no.name.defined");
    //-----------------------------------
    //---- Error messages
    
    /** App will be closed msg*/
    public static String MSG_CLOSE_APP = MessageBundleFactory.getValue("message.close.app");
    
    /** Details field - indicating the error */
    public static String MSG_DETAILS = new StringBuffer()
    .append(Keys.LINE_SEPARATOR)
    .append(Keys.LINE_SEPARATOR)
    .append(MessageBundleFactory.getValue("message.details"))
    .append(Keys.LINE_SEPARATOR).toString();
    
    /** Critical error*/
    public static String MSG_ERR_CRITICAL_ERROR = new StringBuffer()
    .append(MessageBundleFactory.getValue("message.critical.error"))
    .append(Keys.LINE_SEPARATOR)
    .append(MSG_CLOSE_APP).toString();
    
    /** Invalid session error*/
    public static String MSG_ERR_INVALID_SESSION = new StringBuffer()
    .append(MessageBundleFactory.getValue("message.invalid.session"))        
    .append(Keys.LINE_SEPARATOR)
    .append(MSG_CLOSE_APP).toString();
    
    
    /** Error during session removal */
    public static String MSG_ERR_REMOVING_SESSION = new StringBuffer()
    .append(MessageBundleFactory.getValue("message.session.removal.error"))
    .append(MessageBundleFactory.getValue("message.contact.admin"))
    .append(Keys.LINE_SEPARATOR)
    .append(MessageBundleFactory.getValue("message.session.removal.error.conseq"))
    .append(Keys.LINE_SEPARATOR)
    .append(MSG_CLOSE_APP).toString();
    
    
    /** Error during app closing*/
    public static String MSG_ERR_INVALID_CLOSING = new StringBuffer()
    .append(MessageBundleFactory.getValue("message.app.invalid.close"))
    .append(Keys.LINE_SEPARATOR)
    .append(MessageBundleFactory.getValue("message.contact.admin")).toString();
    
    
    //-----------------------------------
    //---- Proxy
    /** Invalid proxy warinnig */
    public static String MSG_WARN_INVALID_PROXY = new StringBuffer()
    .append(MessageBundleFactory.getValue("message.proxy.invalid.proxy"))
    .append(Keys.LINE_SEPARATOR)
    .append(MessageBundleFactory.getValue("message.proxy.dms.disabled.warn")).toString();
    
}
