/*
 * Keys.java
 *
 * Created on 21 kwiecie� 2002, 20:20
 */

package pl.psnc.vlab.ssa.util;

import java.awt.Color;

/** All application keys are stored in here.
 * @author Osa
 * @version 1.0
 * @email osa@man.poznan.pl
 */
public final class Keys {
    
    /** System line separator  I.e. "\n" in Linux systems */
    public static String LINE_SEPARATOR = System.getProperty("line.separator");
    
    /** System file separator. I.e. "/" in Linux systems */
    public static String FILE_SEPARATOR = System.getProperty("file.separator");
    
    
    /** User home directory */
    public static String HOME_DIRECTORY=System.getProperty("user.home");
    
    /** Directory containing images */
    public static String IMAGE_DIRECTORY="images/";
    
    
    // ------------------------------------------------------------------
    // -- System settings
    
    /** Extension of the config file */
    public static String SYSTEM_CONF_EXT = ".conf";
    
    
    //------------------------------------------------------------------
    /** Time format*/
    public static String TIME_FORMAT = "kk:mm:ss a";
    /** Date format*/
    public static String DATE_FORMAT = "dd, MMMM yyyy";
    
        
    //-----------------------------------------------------
    // App exit codes
    //** Ok exit code */
    public static int EXIT_CODE_OK = 0;
    
    //** Error exit code */
    public static int EXIT_CODE_ERROR = -1;
    
    //-----------------------------------------------------
    // Application properties which are sent by VLab Portal
    
    /** Session Key */
    public static String PROPERTY_SESSION_KEY   =   "key";
    
    
    
    //-----------------------------------------------------
    // Timers
    
    /** manager timer delay */
    public static int MANAGER_TIMER_DELAY =  3 * 60 *1000;
    
    /** inti applicaation data timer */
    public static int INIT_APP_DATA_TIMER_DELAY =  1000;
    
    
    //-----------------------------------------------------
    // VLBI resources
    
    /** Path to the resource list */
    public static String RESOURCE_LIST = "http://melisa.man.poznan.pl:8080/wfm/resources/vlbi_resource_list.xml";
 
    /** Path to the resource list */
    public static String LINK_RULES_LIST = "http://melisa.man.poznan.pl:8080/wfm/resources/vlbi_links_rules.xml";
        
    /** Path to the types list */
    public static String TYPES_LIST = "http://melisa.man.poznan.pl:8080/wfm/resources/tds.xml";
    
    
    /** Path to the java types - components */
    public static String CDS_LIST = "http://melisa.man.poznan.pl:8080/wfm/resources/cds.xml";
    
 
    
    
}

