/*
 * OperationsIds.java
 *
 * Created on 12 marzec 2004, 10:50
 */

package pl.psnc.vlab.ssa.util;

import pl.psnc.vlab.remote.util.VlabRemoteKeys;

/**
 * This class contains operations ids which are sent to the vlab modules. This
 * the extension of the Vlab Remote Keys and specifies the specific keys to the SSA
 * @author  osa
 * @email osa@man.poznan.pl
 */
public final class SSARemoteKeys extends VlabRemoteKeys {
            
    
    //------------------------------------------------
    //-------   The size of structs
    /** The size of the generic sql query request structure */
    public static final int GENERIC_QUERY_REQUEST_SIZE = 128 + 4 + 256 + 128;
    
    
    
    //------------------------------------------------
    //-------   Operations IDs
    
    /** Submmit new scenario */
    public static final int OP_SUBMIT_SCENARION = 30101;
    
    //--------------------------------------------------------------------------
    //-- Monitoring Operations
        
    //------
    //- The generic database query
    public static final int MONITORING_GENERIC_QUERY		= monitoringSych("016");   //executes the generic sql query
    
    
    //------
    //- Xml files
    public static final int MONITORING_GET_JAVA_TYPES       = monitoringSych("011");   //get the list of java types
    /** The VLab resource */
    public static final int MONITORING_GET_RESOURCES        = monitoringSych("013");   //get the list of VLab resources
    /** The VLab resource types */
    public static final int MONITORING_GET_RESOURCE_TYPES   = monitoringSych("014");   //get the list of resource types
    /** The VLab resource links */
    public static final int MONITORING_GET_RESOURCE_LINKS   = monitoringSych("012");   //get the list of resource links
    
}
