/*
 * XmlSerializer.java
 *
 * Created on 30 lipiec 2004, 17:22
 */

package pl.psnc.vlab.xml.util;

import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import pl.psnc.vlab.ssa.util.Keys;

/**
 *
 * @author  Dominik Stoklosa
 * @email  osa@man.poznan.pl
 */
public class XmlSerializer {
    
    private final static String TMP_FILE = new StringBuffer().
    append(Keys.HOME_DIRECTORY).append(Keys.FILE_SEPARATOR).append("ssa.dat").toString();
    
    /** Logger instance */
    private static Log log = LogFactory.getLog("XmlSerializer");
    
    
    
    /**
     * Encode the given object into the xml representation
     * @param o
     * @return
     */
    public static String encode(Object o){
        log.debug("<encode>");
        if(o == null){
            log.debug("</encode: null>");
            return null;
        }
        try{
            ByteArrayOutputStream outStream = new ByteArrayOutputStream();            
            XMLEncoder e = new XMLEncoder(new BufferedOutputStream(outStream));
            e.writeObject(o);
            e.flush();
            e.close();                        
            log.debug("</encode>");
            //return res.toString();
            return outStream.toString();
        } catch(Exception e){
            return null;
        }
    }
    
    
    /**
     * Get an object from its xml representation.
     * @param o
     * @return
     */
    public static Object decode(String xmlRep){
        log.debug("<decode>");
        if(xmlRep == null){
            log.debug("</decode: null>");
            return null;
        }
        try{
            XMLDecoder decoder = new XMLDecoder(new ByteArrayInputStream(xmlRep.getBytes()));
            Object o = decoder.readObject();
            log.debug("</decode>");
            return o;
        } catch(Exception e){
            return null;
        }
    }
}
